capture log close
set more off
clear
// Project: Nexus Tax Laws and Economies of Density in E-Commerce: A Study of Amazon’s Fulfillment Center Network
// Authors: Houde, Newberry, Seim
// Created by: Peter Newberry
// Date: 05/2022
// Description: creates the main data sets for the demand analysis. 

// create transaction data
do "trans_subcat.do"

// create extensive margin data: probablity a household (given set of demos) makes at least one purchase online
do "hh_purch_prob.do"

// create household expenditures in each year on the three different modes from a combination of comscore data and the forrester probablities created in the previous step.
do "hh_expenditure.do"

// create the population weights used to aggregate the data
do "population_weights.do"

// create the factor that scales up expenditures to mathc what is observed in financial reports, etc.
do "scale_factor.do"

// create mean/median prices and measures of price disperision
do "price_moments.do"
