#include<oxstd.h>
#import <maximize>
#import <solvenle>
#include <oxdraw.h>
#include <oxfloat.h>
#include <oxprob.h>

#import<Cost_function_moments_continuous>
#import<Swap_diff_varname>
#import<CI_func>

decl swapid,year,revenue,net_revenue,labor_cost,land_cost,density_cap,density,network_distance,network_density,
  ship_int,ship_dist,ship_vi,ship_vi_dist,avg_wage,avg_rent,avg_density,hh_dist,hh_dist_vi,hh_vi,
  hh_dist_nearest,hh_dist_vi_nearest,hh_vi_nearest,swap_year0,swap_dyear,
  swap_distance,swap_capacity,swap_type,tax_avg,tax_hh,inc_dist,young_dist,inc_dist_nearest,young_dist_nearest;
/* Global variables */
decl OPTid,vParam0,typeid,vParam_scale,vParam_upper,vParam_lower;
decl mZ,vY,mX,Tn,iPenalty,mRandomGrid,seed,mU,mBlockID,simid,vParam_est,paramid,iUpper_dummy,iLower_dummy,mDummy_cluster;
decl vZY,mZX,mZdotY,mClusterX,mClusterZ,mClusterZY;
decl mDummyFC,iCluster;
decl iprint;
decl iSpec;

test_diff(const avF, const vX)
{
  decl vTest_grid,vParam_est_grid;
  decl alpha=0.05;
  decl vParam_restrict=vParam_est;
  vParam_restrict[paramid]=vX;
  TestMR(&vTest_grid,&vParam_est_grid,vParam_restrict,alpha);
  println("Test: ","%c",{"paramid","grid","est","Tn","Tmr","norm"},
	  paramid~vX~vParam_est[paramid]~vTest_grid~fabs(vTest_grid[0]-vTest_grid[1]));
  //if(isnan(vTest_grid)==0) avF[0]=fabs(vTest_grid[0]-vTest_grid[1])+(vParam_est[paramid]<vX)*iLower_dummy+(vParam_est[paramid]>vX)*iUpper_dummy;
  if(isnan(vTest_grid)==0) avF[0]=fabs(vTest_grid[0]-vTest_grid[1]);
  else avF[0]=.NaN;
  return 1;
}
grid_search(const aX)
{
  decl step=fabs(0.01*aX[0]);
  decl vParam_restrict=vParam_est;
  vParam_restrict[paramid]=aX[0];
  decl vTest_grid,vParam_est_grid;
  decl diff,alpha=0.05;
  decl it=0;
  do{
    if(it>0) {
      if(iUpper_dummy) vParam_restrict[paramid]+=step;
      if(iLower_dummy) vParam_restrict[paramid]-=step;
    }
    println("grid: ",vParam_restrict[paramid]);
    TestMR(&vTest_grid,&vParam_est_grid,vParam_restrict,alpha);
    if(isnan(vTest_grid)) diff=-1;
    else diff=vTest_grid[0]-vTest_grid[1];
    println("Test: ","%c",{"it","paramid","grid","est","Tn","Tmr","norm"},
	    it~paramid~vParam_restrict[paramid]~vParam_est[paramid]~vTest_grid~fabs(diff));
    it+=1;
  }while(diff<0);
  decl bound=vParam_restrict[paramid]-iUpper_dummy*step+iLower_dummy*step;
  println("Grid search after it ",it," bound: ",bound);
  aX[0]=bound;
  return 1;
}
grid_plot(const aX)
{
  decl step=fabs(0.01*vParam_est[paramid]);
  decl vParam_restrict=vParam_est;
  decl vTest_grid,vParam_est_grid;
  decl diff,alpha=0.05;
  decl it=0;
  decl mTest_grid=<>;
  decl max_step=100;
  do{
    if(it>0) {
      if(iUpper_dummy) vParam_restrict[paramid]+=step;
      if(iLower_dummy) vParam_restrict[paramid]-=step;
    }
    println("grid: ",vParam_restrict[paramid]);
    TestMR(&vTest_grid,&vParam_est_grid,vParam_restrict,alpha);
    if(isnan(vTest_grid)) diff=-1;
    else diff=vTest_grid[0]-vTest_grid[1];
    println("vTest_grid: ",vTest_grid);
    println("Test: ","%c",{"it","paramid","grid","est","Tn","Tmr","norm"},
	    it~paramid~vParam_restrict[paramid]~vParam_est[paramid]~vTest_grid~fabs(diff));
    it+=1;
    mTest_grid|=vParam_restrict[paramid]~vTest_grid;
  }while(it<max_step);
  aX[0]=mTest_grid;
  return 1;
}

main()
{
  decl i;
  decl main_dir="../../Data/Processed/Main/";
  decl swap_dir="../../Data/Processed/Swap_list/";
  decl scale=1000000;
  decl iTaxDelay=2;
  decl iEstimator="NLS";
  decl iVariety=1;
  decl aVarName_list,aVarName_diff;
  decl mSwap_list=loadmat(sprint(swap_dir,"Swap_list.dta"),&aVarName_list);
  decl nbSwap=rows(mSwap_list);
  decl demand_spec=2;
  iSpec=0;
  println("Estimator (Logistic): ",iEstimator);
  println("Tax delay: ",iTaxDelay);
  println("Moment spec: ",iSpec);
  println("iVariety: ",iVariety);
  mSwap_list=sortbyc(mSwap_list,find(aVarName_list,"swapid"));
  decl mSwap_diff=loadmat(sprint(swap_dir,"Swap_diff_components_taxdelay",iTaxDelay,"_",iEstimator,"_variety",iVariety,"_demandspec",demand_spec,".in7"),&aVarName_diff)[:nbSwap][];
  decl vDiscounted_charact=selectifr(mSwap_diff,mSwap_diff[][0].==0);
  mSwap_diff=deleteifr(mSwap_diff,mSwap_diff[][0].==0);
  diff_varname(aVarName_diff);
  println("rows swap diff: ",rows(mSwap_diff));
  
  /* Select valid permutations */
  mSwap_diff=sortbyc(mSwap_diff,swapid);
  decl vID=range(0,rows(mSwap_diff)-1)';
  vID=selectifr(vID,(mSwap_diff[vID][swap_type].==2)+(mSwap_diff[vID][swap_type].==4)+(mSwap_diff[vID][swap_type].==9));
  vID=selectifr(vID,mSwap_list[vID][find(aVarName_list,"cyearA")].==2400);
  vID=selectifr(vID,mSwap_list[vID][find(aVarName_list,"cyearB")].==2400);
  vID=selectifr(vID,mSwap_list[vID][find(aVarName_list,"oyearA")].>1999);
  vID=selectifr(vID,mSwap_diff[vID][swap_distance].>0);
  mSwap_diff=mSwap_diff[vID][];
  mSwap_list=mSwap_list[vID][];
  println("rows ID: ",rows(mSwap_diff));

  //println("%r",aVarName_diff,(meanc(mSwap_diff)|sqrt(varc(mSwap_diff)))');
  println("%r",aVarName_diff,"%c",{"median","iqr"},(quantilec(mSwap_diff)|(quantilec(mSwap_diff,0.75)-quantilec(mSwap_diff,0.25)))');
  
  /* Extract vector of FC-ID */
  decl vFCidA=mSwap_list[][find(aVarName_list,"fc_idA")];
  decl vFCidB=mSwap_list[][find(aVarName_list,"fc_idB")];
  decl vOYearA=mSwap_list[][find(aVarName_list,"oyearA")];
  decl vOYearB=mSwap_list[][find(aVarName_list,"oyearB")];
  decl vSwap_dist=mSwap_list[][find(aVarName_list,"swap_dist")];
  decl vSwap_type_sc=mSwap_list[][find(aVarName_list,"typeidA")].==9;
  decl vSwap_size=mSwap_list[][find(aVarName_list,"sq_ftA")];
  decl vSwap_size_diff=mSwap_list[][find(aVarName_list,"diff_size")];
  println("unique type: ",unique(vSwap_type_sc));
  println("aVarName_list: ",aVarName_list);

  /* Starting values */
  decl vParam_start=new matrix[5][1];
  vParam_start[0]=0;
  vParam_start[1]=0;
  vParam_start[2]=0;
  vParam_start[3]=0;
  vParam_start[4]=0;
  vParam_upper=<1;1;1;1;1>;  vParam_lower=<0;0;0;0;0>;
  decl vParam_transform=vParam_start./(vParam_upper-vParam_lower);  
  decl Q;  
  decl iConv,vP; 

  /* Initial parameter vector */
  //OPTid=<1>;
  //OPTid=<1;3>;
  //OPTid=<1;3>;
  OPTid=<1;2;3>;  
  decl OPTid_full=OPTid;
  println("nb param: ",rows(OPTid_full));
  
  MaxControl(100,0);
  simid=0;  
  vP=vParam_transform[OPTid];
  vParam0=vParam_transform;

  /* IVs */
  decl mZ_combined;
  IV_func(&mZ_combined,mSwap_diff);
  
  decl vID0=vecindex(sumr(mZ_combined),0);
  decl vID1=vecindex(sumr(mZ_combined).>0,1);
  println("fraction of permuntations used: ",rows(vID1)/rows(vID));
  
  println("rank: ",rank(mZ_combined[vID1][]));
  println("columns Z: ",columns(mZ_combined[vID1][]));

  /* Explanatory variables */
  vY=mSwap_diff[vID1][net_revenue]-sumr(mSwap_diff[vID1][labor_cost~land_cost]);
  mX=mSwap_diff[vID1][ship_int~ship_dist~ship_vi~density_cap~network_distance];
  mZ=mZ_combined[vID1][];
  vFCidA=vFCidA[vID1];
  vFCidB=vFCidB[vID1];
  vOYearA=vOYearA[vID1];
  vOYearB=vOYearB[vID1];
  decl mDummyFC_A=vFCidA.==unique(vFCidA);
  decl mDummyFC_B=vFCidB.==unique(vFCidB);
  decl vUnique_ID_B=unique(vFCidB);
  decl vFreq_ID_B=meanc(mDummyFC_B);
  decl vCumu_ID_B=cumulate(vFreq_ID_B')';
  println("nb of FC (A): ",columns(unique(vFCidA)));
  println("mean/stdv: ",quantilec(vY~mX)|meanc(vY~mX)|sqrt(varc(vY~mX)));
  println("mean/sd Z :",meanc(mZ)|sqrt(varc(mZ)));
  decl mDummy_oyear_A=vOYearA.==unique(vOYearA)[2:];
  decl mDummy_oyear_B=vOYearB.==unique(vOYearB)[6:];
  mDummy_cluster=mDummyFC_B;

  /* Pre-Calculate Moments */
  vZY=mZ'vY/rows(vY);
  mZX=mZ'mX/rows(vY);
  mZdotY=mZ.*vY;  

  /* Global variables */
  decl B=10000;
  decl n=rows(vY);
  decl K=rows(vParam_start);
  decl grid=100;
  seed=ranseed(0);
  mRandomGrid=ranu(K,grid)-1/2;
  mRandomGrid=sortbyc(mRandomGrid',OPTid')';

  /* Parameter estimate */
  iCluster=0;
  decl r;
  decl vGridT=new matrix[grid][1],mGridParam=new matrix[rows(OPTid)][grid];
  parallel for(r=0;r<grid;r++)
    {
      vP=mRandomGrid[OPTid][r];
      //iConv=MaxSimplex(qfunc_obs,&vP,&Q,constant(1/2,vP));
      iConv=MaxBFGS(qfunc_obs,&vP,&Q,0,1);
      if(maxc(fabs(vP))>100) {
	iConv=MAX_NOCONV;
	vP=constant(.NaN,vP);
	Q=.NaN;
	vGridT[r]=.NaN;
      }
      if(iConv<=MAX_WEAK_CONV) {
	vGridT[r]=-Q;
	mGridParam[][r]=vP;
      }
      else {
	vGridT[r]=.NaN;
	mGridParam[][r]=vP;
      }
      println("r: ",r," vGridT[r]  = ",vGridT[r]);
    }
  decl Tmin=minc(vGridT);
  decl Tmin_id=mincindex(vGridT);

  /* Optimization set: Distinct parameters corresponding to the minimizing solution */
  decl eps1=10^(-3);
  decl eps2=eps1*10;  
  decl vParam_id=vecindex(fabs((vGridT-Tmin)/(1+Tmin)).<eps1,1);
  decl mTheta_set=mGridParam[][vParam_id[0]];
  println("nb of potential elements in set: ",rows(vParam_id));
  decl vDiff;
  for(i=0;i<rows(vParam_id);i++)
    {
      vDiff=maxc(fabs((mTheta_set-mGridParam[][vParam_id[i]])./mGridParam[][vParam_id[i]]))';
      if(minc(vDiff)>eps2) mTheta_set~=mGridParam[][vParam_id[i]];
    }
  decl grid_theta=columns(mTheta_set);
  mTheta_set=sortbyc(mTheta_set',range(0,rows(OPTid)-1))';
  decl vP_sample=mTheta_set[][floor(grid_theta/2)]; /* Parameter: Mid-point of optimizing set */
  println("vP (sample) : ",vP_sample);
  println("nb of distinct elements: ",grid_theta~rows(vParam_id));

  /* Starting value */
  vParam_start=vParam0;
  vParam_start[OPTid]=vP_sample;
  vParam_start.*=(vParam_upper-vParam_lower);
  println("Starting values: ",vParam_start);
  println("Tmin: ",Tmin);
  vParam_est=vParam_start;
  decl mParam_set=vParam_start.*ones(K,grid_theta);
  mParam_set[OPTid][]=mTheta_set.*(vParam_upper[OPTid]-vParam_lower[OPTid]);
  println("mParam_set: ",mParam_set');

  /* Compute residuals */
  decl mM_obs=(mZ.*(vY-mX*vParam_start));
  decl vMbar_obs=meanc(mM_obs);
  decl vD=varc(mM_obs);
  decl vInvD_sqrt=vD.^(-1/2);
  decl mU_obs=(mM_obs-vMbar_obs).*vInvD_sqrt;
  decl vResid=vY-mX*vParam_start;
  decl vPi;
  olsc(mM_obs,ones(rows(vResid),1)~mDummy_cluster,&vPi);
  decl r2=meanr((varc((ones(rows(mM_obs),1)~mDummy_cluster)*vPi)./varc(mM_obs)));
  //decl r2=0.5;
  println("r2: ",r2);
  println("mean/sqrt Mu_obs: ",meanc(mU_obs)|sqrt(varc(mU_obs)));

  decl mU_cluster=rann(columns(mDummyFC_B),B);
  mU=new matrix[n][B];
  for(i=0;i<B;i++)
    {
      mU[][i]=((mDummy_cluster*mU_cluster[][i])*r2+(1-r2)*rann(n,1));
    }
  mU=(mU-meanc(mU))./sqrt(varc(mU));
  
  /* Compute test statistics */
  decl Tmr;
  decl vGrid;
  paramid=0;
  decl alpha=0.05;
  decl vParam_est_grid,vParam_restrict,vTest_grid;
  iprint=0;
  decl vCI_upper=new matrix[K][1];
  decl vCI_lower=new matrix[K][1];
  decl I,step,vParam_restrict_old,diff,it;
  decl iLower,iUpper;

  if(rows(OPTid_full)==1) {
    /* Upper bound */
    paramid=1;
    OPTid=OPTid_full;
    OPTid=deleter(OPTid,paramid);
    println("OPTid: ",OPTid);  
    decl mTest_grid_upper=<>;
    decl mTest_grid_lower=<>;
    iLower_dummy=0;
    iUpper_dummy=1;
    grid_plot(&mTest_grid_upper);
    iLower_dummy=1;
    iUpper_dummy=0;
    grid_plot(&mTest_grid_lower);
    decl mTest_grid=sortbyc(mTest_grid_lower|mTest_grid_upper,0);
    println("Upper bound grid: ",mTest_grid_upper);
    println("Lower bound grid: ",mTest_grid_lower);
    DrawXMatrix(0,mTest_grid[][<1,2>]',{"Test-statistic","Critical Value"},mTest_grid[][0]',"Parameter");
    ShowDrawWindow();
    SaveDrawWindow(sprint("Results/Test_statistics_grid_taxdelay",iTaxDelay,"_",iEstimator,".pdf"));
  }

  if(rows(OPTid_full)>1) {
  /* Confidence interval: Invert test-statistics */
  iprint=0;
  for(i=0;i<rows(OPTid_full);i++)   
    {
      paramid=OPTid_full[i];
      println("paramid: ",paramid);
      OPTid=OPTid_full;
      OPTid=deleter(OPTid,paramid);
      println("OPTid: ",OPTid);

      /* Upper bound */
      iLower_dummy=0;
      iUpper_dummy=1;
      iUpper=vParam_est[paramid];
      /* Starting values using grid search */
      grid_search(&iUpper);
      /* Exact solution using Solve NLE */
      iConv=SolveNLE(test_diff,&iUpper, 1, 0,10^(-2), 10^(-1),10, 1, 100);      
      vCI_upper[paramid]=iUpper;
      println("Upper Bound: ",iUpper);

      /* Lower bound */
      iLower_dummy=1;
      iUpper_dummy=0;
      iLower=vParam_est[paramid];
      /* Starting values using grid search */
      grid_search(&iLower);
      /* Exact solution using Solve NLE */
      iConv=SolveNLE(test_diff,&iLower, 1, 0,10^(-2), 10^(-1),10, 1, 100);      
      vCI_lower[paramid]=iLower;      
      println("Lower Bound: ",iLower);
    }
  println("CI :",vParam_est~vCI_lower~vCI_upper);
  savemat(sprint("Results/CI_cost_nbparam_",rows(OPTid_full),"_taxdelay",iTaxDelay,"_",iEstimator,"_demandspec",demand_spec,"_cluster",iCluster,"_variety",iVariety,".csv"),
	  vParam_est~vCI_lower~vCI_upper~constant(columns(mZ),rows(vParam_est),1),{"Param_est","CI_lower","CI_upper","nb_IV"});

  }
}


