IV_func(const aZ_combined,const mSwap_diff)
{
  decl i;
  /* Similarity index */
  decl iDist=hh_dist;
  decl iVI=hh_vi;
  decl vIQR=quantilec(mSwap_diff,0.75)-quantilec(mSwap_diff,0.25);
  decl vDummy_fc=mSwap_diff[][swap_type].!=9;
  decl vDummy_sc=mSwap_diff[][swap_type].==9;
  println("IQR capacity: ",vIQR[swap_capacity]);
  decl vDummy_sim_capacity=fabs(mSwap_diff[][swap_capacity]).<vIQR[swap_capacity];
  //vDummy_sim_capacity=constant(1,vDummy_sim_capacity);
  decl vDummy_sim_vi=(fabs(mSwap_diff[][iVI]).<vIQR[iVI]);
  decl vDummy_sim_dist=(fabs(mSwap_diff[][iDist]).<vIQR[iDist]);
  decl vDummy_zero_tax=mSwap_diff[][tax_avg].==0;
  decl vDummy_sim_density=fabs(mSwap_diff[][density]).<vIQR[density]/2;
  decl vDummy_sim_cost=(fabs(mSwap_diff[][avg_wage]).<vIQR[avg_wage]/2).*(fabs(mSwap_diff[][avg_rent]).<vIQR[avg_rent]/2);
  
  /* Increase/decrease indicators */
  decl vDummy_cost_increase=(meanr(mSwap_diff[][avg_rent~avg_wage]).>0);
  decl vDummy_cost_decrease=(meanr(mSwap_diff[][avg_rent~avg_wage]).<0);
  
  decl vDummy_density_increase=(mSwap_diff[][density].>0);
  decl vDummy_density_decrease=(mSwap_diff[][density].<0);
  
  decl vDummy_dist_increase=mSwap_diff[][iDist].>vIQR[iDist]*0;
  decl vDummy_dist_decrease=mSwap_diff[][iDist].<-vIQR[iDist]*0;

  decl vDummy_dist_vi_increase=(mSwap_diff[][hh_dist_vi].>0);
  decl vDummy_dist_vi_decrease=(mSwap_diff[][hh_dist_vi].<0);
  
  decl vDummy_vi_increase=(mSwap_diff[][iVI].>vIQR[iVI]*0);
  decl vDummy_vi_decrease=(mSwap_diff[][iVI].<-vIQR[iVI]*0);
  
  decl vDummy_netdist_increase=mSwap_diff[][network_distance].>vIQR[network_distance]*0;
  decl vDummy_netdist_decrease=mSwap_diff[][network_distance].<vIQR[network_distance]*0;
  
  decl vDummy_capacity_increase=mSwap_diff[][swap_capacity].>0;
  decl vDummy_capacity_decrease=mSwap_diff[][swap_capacity].<0;    
  decl vDummy_tax_increase=mSwap_diff[][tax_avg].>0;
  decl vDummy_tax_decrease=mSwap_diff[][tax_avg].<0;
  decl vDummy_inc_dist_increase=mSwap_diff[][inc_dist].>0;
  decl vDummy_inc_dist_decrease=mSwap_diff[][inc_dist].<0;
  decl vDummy_young_dist_increase=mSwap_diff[][young_dist].>0;
  decl vDummy_young_dist_decrease=mSwap_diff[][young_dist].<0;
 
  decl mW=fabs(mSwap_diff[][tax_avg~swap_capacity]~meanr(mSwap_diff[][avg_wage~avg_rent]));

  /* IVs: Indicator variables */
  decl mZ_transaction=vDummy_sim_capacity.*((vDummy_tax_increase.*vDummy_sim_dist.*vDummy_sim_vi)~(vDummy_tax_decrease.*vDummy_sim_dist.*vDummy_sim_vi));
  //decl mZ_transaction=vDummy_sim_capacity.*((vDummy_tax_increase)~(vDummy_tax_decrease));
  println("mean Z transaction: ",sumc(mZ_transaction));
  
  decl mZ_vi=vDummy_sim_capacity.*(vDummy_vi_increase.*vDummy_cost_increase
				   ~vDummy_vi_increase.*vDummy_tax_increase
				   ~vDummy_vi_decrease.*vDummy_cost_decrease
				   ~vDummy_vi_decrease.*vDummy_tax_decrease);
  decl mZ_network=vDummy_sim_capacity.*((vDummy_netdist_increase.*vDummy_cost_decrease)
					~(vDummy_netdist_increase.*vDummy_tax_decrease)
					~(vDummy_netdist_decrease.*vDummy_cost_increase)
					~(vDummy_netdist_increase.*vDummy_tax_increase)
					~(vDummy_netdist_increase.*vDummy_dist_decrease)
					~(vDummy_netdist_decrease.*vDummy_dist_increase));
  
  println("sum Z vi: ",sumc(mZ_vi));
  //println("sum Z network: ",sumc(mZ_network));
  decl mZ_distance=vDummy_sim_capacity.*(vDummy_dist_decrease.*vDummy_cost_increase
					 ~vDummy_dist_decrease.*vDummy_tax_increase
					 ~vDummy_dist_increase.*vDummy_cost_decrease
					 ~vDummy_dist_increase.*vDummy_tax_decrease);
  decl mZ_vi_dist=vDummy_sim_capacity.*((vDummy_dist_decrease.*vDummy_vi_decrease)~(vDummy_dist_increase.*vDummy_vi_increase));
    
  println("sum Z distance: ",sumc(mZ_distance));  
  println("sum Z vi/distance interaction : ",sumc(mZ_vi_dist));
  
  decl mZ_density_dist=vDummy_sim_capacity.*((vDummy_density_increase.*vDummy_dist_decrease)
					     ~(vDummy_density_decrease.*vDummy_dist_increase));
  decl mZ_density_vi=vDummy_sim_capacity.*((vDummy_density_increase.*vDummy_vi_increase)
					   ~(vDummy_density_decrease.*vDummy_vi_decrease));
  decl mZ_density_network=vDummy_sim_capacity.*((vDummy_density_increase.*vDummy_netdist_decrease)
						~(vDummy_density_decrease.*vDummy_netdist_increase));

  println("sum Z density distance: ",sumc(mZ_density_dist));
  decl mZ_combined=<>;
  if(vecindex(OPTid,1)!=<>) mZ_combined~=mZ_distance;
  if(vecindex(OPTid,2)!=<>) mZ_combined~=mZ_vi~mZ_vi_dist;
  if(vecindex(OPTid,3)!=<>) mZ_combined~=mZ_transaction~mZ_density_dist;
  if(vecindex(OPTid,4)!=<>) mZ_combined~=mZ_network~mZ_density_network;
  
  decl mZ_interactions=<>;
  for(i=0;i<columns(mZ_combined);i++)
    {
      mZ_interactions~=mZ_combined[][i].*mW;
    }
  if(iSpec==0) aZ_combined[0]=mZ_combined;
  if(iSpec==1) aZ_combined[0]=mZ_interactions;  
  return 1;
}
