#include<oxstd.h>
#import <maximize>
#import <solvenle>
#include <oxdraw.h>
#include <oxfloat.h>
#include <oxprob.h>

enum{cross_county_code,cross_cluster_id,cross_dist,cross_congest_dist}; /* Cross-section: County-cluster list */
enum{type_fresh=1,type_nonsortable,type_prime,type_sortable,type_callcenter,type_idx,type_returns,type_delivery,type_sortation};

enum{cluster_id0,cluster_lat0,cluster_long0,cluster_state_code0,cluster_county_code0,cluster_density0,cluster_id1,
     cluster_lat1,cluster_long1,cluster_state_code1,cluster_county_code1,cluster_density1,
     cluster_dist,congestion,cluster_congest_dist}; /* Cluster distance */

enum{demo_state_code,demo_year,demo_pop_density,demo_nb_hh,demo_median_income,demo_house_value,
     demo_county_code,demo_rent,demo_wage,demo_lon,demo_lat,demo_tax,demo_amazon_tax,demo_msize,
     demo_hhincome_100000more,demo_mean_age,demo_pop_young,demo_share_young}; /* County-Demographic file */

enum{demand_year,demand_county,demand_mode,demand_nb_hh,demand_avg_spending_annual_county,
     demand_alpha,demand_tax_rate,demand_tax_status,demand_density1,demand_perc_100,demand_tax_coeff,
     demand_tax_coeff100,demand_density_coeff,demand_am_share,demand_margin0,demand_prods_per,
     demand_pre_laprice1,demand_pre_lmprice1,demand_pre_liquart1,demand_pre_lstd1,demand_a_margin,demand_mp_margin}; /* Demand variables */

enum{fc_cluster_id,fc_id,fc_county_code,fc_sq_ft,fc_oyear,fc_cyear,fc_typeid,fc_cluster_lat,
     fc_cluster_lng,fc_swapid,fc_year,fc_pop_density,
     fc_county_rent_dis_imputed,fc_imputed_wage,fc_state_code,fc_state_abbrev,fc_dummy_active};/* Facility panel */

enum{swap_county_code,swap_state_code,swap_year}; /* Swap files */

enum{out_swapid,out_year,out_net_revenue,out_labor_cost,out_land_cost,out_density_cap,out_density,out_network_distance,out_network_density,out_ship_int,out_ship_dist,
     out_ship_vi,out_ship_vi_dist,out_avg_wage,out_avg_rent,out_avg_density,out_hh_dist,out_hh_dist_vi,out_hh_vi,out_inc_dist,out_young_dist,out_hh_dist_nearest,
     out_hh_dist_vi_nearest,out_hh_vi_nearest,out_inc_dist_nearest,out_young_dist_nearest,out_swap_year0,out_swap_dyear,
     out_swap_distance,out_swap_capacity,out_swap_type,out_tax_avg,out_tax_hh,nbOutput_var};

decl aOutput_varname={"swapid","year","net_revenue","labor_cost","land_cost","density_cap","density","network_distance","network_density_dist",
		      "ship_int","ship_dist","ship_vi","ship_vi_dist","avg_wage","avg_rent","avg_density","hh_dist","hh_dist_vi","hh_vi","inc_dist","young_dist",
		      "hh_dist_nearest","hh_dist_vi_nearest","hh_vi_nearest","inc_dist_nearest","young_dist_nearest","swap_year0","swap_dyear",
		      "swap_distance","swap_capacity","swap_type","tax_avg","tax_hh"};

#import<logistic_func>
#import<spending_func>


/* Common variables */
enum{imu_0,imu_k,imu_t,ialpha,iAfc,iAsc,ibeta,igamma,nbParam};
enum{iShip_int,iShip_dist,iShip_vi,iFC_dens};
enum{iNetwork_sortation,iSortation_zone,iDist_fc_sc};
decl aParamName={"$\\mu_0$","$\\mu_k$","$\\mu_t$","$\\alpha$","$A_{fc}$","$A_{sc}$","$\\beta$","$\\gamma$"};
decl vYear,vVariety;
decl N,M,T,nbFC;
decl mDist_county_cluster;
decl mFC_activity,vFC_capacity,vFC_type;
decl mDistance_cluster;
decl vParam_logistic,vOPTid;
decl vCluster_id,vCounty_id,vUnique_fcid;
decl vFC_oyear,vFC_id,aID,vDummy_fc,vDummy_sc;
decl mDummy_cluster_county,vTax_delay,mTotalSpending,mCES_param,iMu_param,iMu_amazon,iMu_mp,aSpendingInt,scale,vState_code;
decl vAmazonShare,mAmazonPrice_tax_excl,mRetailSpending;
decl vNearestCounty_id,mCounty_wage,mCounty_rent,mCounty_density,mCounty_tax,mCounty_hh,mCluster_wage,mCluster_density,mCluster_rent,vParam_cost;
decl mCounty_high_income,mCounty_age,mCounty_share_young,mCounty_pop_young;
decl iSortThreshold=150;
decl iFCThreshold=25;
decl iMinDist=25;
decl iConvenience;
decl iprint=0;

/************************************************************/
/* Specifications */
decl iTaxDelay,iVariety,iDensityParam,iLargeCES,iEstimator;
/*************************************************************/

swap_value(const demand_spec)
{
  format(1000);
  decl i,j,k;
  /**********************************************************/
  /* Parameters */
  decl demand_spec=2;
  decl OPTid=<1;2;3>;
  decl iCluster=0;
  vParam_logistic=loadmat(sprint("Results/matching_function_param_",iEstimator,"_variety",iVariety,"_spec",demand_spec,".mat"));
  decl mParam_cost_CI=loadmat(sprint("Results/CI_cost_nbparam_",rows(OPTid),"_taxdelay",iTaxDelay,"_",iEstimator,"_cluster",iCluster,".csv"));
  println("Param CI: ",mParam_cost_CI);
  vParam_cost=new matrix[4][1];
  vParam_cost=mParam_cost_CI[][0];

  println("param_cost: ",vParam_cost);
  println("shipping cost param (dist): ",vParam_cost[iShip_dist]);
  println("shipping cost param (vi): ",vParam_cost[iShip_vi]);
  println("shipping cost param (density): ",vParam_cost[iFC_dens]);
  
  println("%r",aParamName,vParam_logistic);
  println("Tax Delay indicator : ",iTaxDelay);
  println("Variety: ",iVariety);
  println("Convenience: ",iConvenience);
  println("iEstimator: ",iEstimator);
  println("iLargeCES: ",iLargeCES);
  println("iSortThreshold: ",iSortThreshold);
  println("iFCThreshold: ",iFCThreshold);
  
  /**********************************************************/
  /* Load Data-sets: Fixed covariates */
  decl output_dir="../output/";
  decl main_dir="../../Data/Processed/Main/";
  decl swap_dir="../../Data/Processed/Swap_list/";
  scale=1000000; /* Capacity and revenue scale variable */
  decl aVarName_cross,aVarName_fc,aVarName_distance;
  decl mCrossData=loadmat(sprint(main_dir,"Distance_matrix_county_cluster.dta"),&aVarName_cross);
  decl mFacilityData=loadmat(sprint(swap_dir,"Facility_panel_swap0.dta"),&aVarName_fc);
  mFacilityData[][fc_sq_ft]./=scale;
  decl mDistanceData=loadmat(sprint(main_dir,"Cluster_distance_threshold20.dta"),&aVarName_distance);
  decl aVarName_demo;
  decl mDemoData=loadmat(sprint(main_dir,"County_demo_variables.dta"),&aVarName_demo);
  mDemoData=sortbyc(mDemoData,<demo_county_code,demo_year>);  
  println("%r",aVarName_demo,(meanc(mDemoData)|sqrt(varc(mDemoData)))');
  decl aVarName_variety;
  decl mVariety_index=loadmat(sprint(main_dir,"Variety_index_spec",demand_spec,".dta"),&aVarName_variety);
  println("%c",aVarName_variety,mVariety_index);
  vVariety=mVariety_index[][1]';

  decl aSpendingVar_names;
  decl mSpendingComponents=loadmat(sprint(main_dir,"ces_data",demand_spec,".csv"),&aSpendingVar_names);
  /*********MODEL CHANGES DEPENDING ON HOW WE TREAT THE REGION EFFECTS.**********/ 
  /**********MODEL=0 NO REGION EFFECTS********************************************/
  /*********MODEL=1 REGION EFFECTS************************************************/
  /*********MODEL=2 DISTRICT EFFECTS********************************************* (baseline) */
  /*********MODEL=3 REGION AMAZON EFFECTS****************************************/
  /*********MODEL=4 DISTRICT AMAZON EFFECTS**************************************/
  /*********MODEL=5 REGION AMAZON EFFECTS 2015-2016******************************/
  /*********MODEL=6 DISTRICT AMAZON EFFECTS  2015-2016***************************/
  mSpendingComponents=sortbyc(mSpendingComponents,<demand_mode,demand_county,demand_year>);
  println("unique modes: ",unique(mSpendingComponents[][demand_mode]));
  decl mSpendingComponents_mode1=selectifr(mSpendingComponents,mSpendingComponents[][demand_mode].==1);
  decl mSpendingComponents_mode2=selectifr(mSpendingComponents,mSpendingComponents[][demand_mode].==2);
  decl mSpendingComponents_mode3=selectifr(mSpendingComponents,mSpendingComponents[][demand_mode].==3);

  println("%r",aVarName_fc,meanc(mFacilityData)'~sqrt(varc(mFacilityData))');
  println("%r",aVarName_demo,meanc(mDemoData)'~sqrt(varc(mDemoData))');
  
  /* Sort cross-data by county and cluster ID */
  mCrossData=sortbyc(mCrossData,<cross_county_code,cross_cluster_id>);
  mFacilityData=sortbyc(mFacilityData,<fc_id,fc_year>);
  mDistanceData=sortbyc(mDistanceData,<cluster_id0,cluster_id1>);
  println("unique type: ",unique(mFacilityData[][fc_typeid]));
 
  /* Vector of IDs */
  vCluster_id=unique(mCrossData[][cross_cluster_id]);
  vCounty_id=unique(mCrossData[][cross_county_code]);
  vUnique_fcid=unique(mFacilityData[][fc_id]);
  vYear=unique(mFacilityData[][fc_year]);
  N=columns(vCluster_id);
  M=columns(vCounty_id);
  T=columns(vYear);
  nbFC=columns(vUnique_fcid);
  println("N : ",N);
  println("M : ",M);
  println("nbFC : ",nbFC);
  println("T : ",T);

  /* Reshape wide distance matrix */
  mDistance_cluster=reshape(mDistanceData[][cluster_dist],N,N);
  mDist_county_cluster=reshape(mCrossData[][cross_dist],M,N)+iMinDist;

  /* Reshape input price and tax variables */
  mCounty_wage=reshape(mDemoData[][demo_wage],M,T);
  mCounty_rent=reshape(mDemoData[][demo_rent],M,T);
  mCounty_density=reshape(mDemoData[][demo_pop_density],M,T);
  mCounty_hh=reshape(mDemoData[][demo_nb_hh],M,T);
  mCounty_tax=reshape(mDemoData[][demo_tax],M,T);
  mCounty_high_income=reshape(mDemoData[][demo_hhincome_100000more],M,T).*mCounty_hh;
  mCounty_age=reshape(mDemoData[][demo_mean_age],M,T);
  mCounty_share_young=reshape(mDemoData[][demo_share_young],M,T);
  mCounty_pop_young=reshape(mDemoData[][demo_pop_young],M,T);
  decl iAvgDensity=sumc(mCounty_density[][T-1].*mCounty_hh[][T-1])./sumc(mCounty_hh[][T-1]);
  
  vState_code=reshape(mDemoData[][demo_state_code],M,T)[][0];
  //if(iTaxDelay==1) vTax_delay=(vYear.<2006).*(2006-vYear+2)+(vYear.>=2006).*(vYear.<=2010).*(2010-vYear+1)+(vYear.>=2010)*0;
  if(iTaxDelay==2) vTax_delay=(vYear.<2008).*(5)+(vYear.>=2008).*(vYear.<=2010).*2+(vYear.>2010)*0;
  if(iTaxDelay==0) vTax_delay=zeros(1,T);
  println("Tax Delay: ",(vYear|vTax_delay|(vYear+vTax_delay))');   
  println("%c",{"year","variety ratio"},(vYear|vVariety)');

  /* Reshape wide */
  iMu_param=unique(mSpendingComponents_mode1[][demand_margin0]);
  iMu_amazon=unique(mSpendingComponents_mode1[][demand_a_margin]);
  iMu_mp=unique(mSpendingComponents_mode1[][demand_mp_margin]);
  println("markup: ",iMu_param~iMu_amazon~iMu_mp);
  println("Profit margin: ",iMu_param);
  decl mSpendingAlpha_mode1=reshape(mSpendingComponents_mode1[][demand_alpha],M,T);
  decl mSpendingAlpha_mode2=reshape(mSpendingComponents_mode2[][demand_alpha],M,T);
  decl mSpendingAlpha_mode3=reshape(mSpendingComponents_mode3[][demand_alpha],M,T);
  aSpendingInt=new array[3];
  aSpendingInt[0]=mSpendingAlpha_mode1;
  aSpendingInt[1]=mSpendingAlpha_mode2;
  aSpendingInt[2]=mSpendingAlpha_mode3;
  
  /* Construct matrices of amazon characteristics */
  vAmazonShare=reshape(mSpendingComponents_mode1[][demand_am_share],M,T)[0][];
  mRetailSpending=reshape(mSpendingComponents_mode1[][demand_avg_spending_annual_county],M,T);
  mAmazonPrice_tax_excl=reshape(mSpendingComponents_mode1[][demand_pre_laprice1],M,T);
  println("Amazon Share: ",vAmazonShare);
  decl vAvgPrice_tax_excl=sumc(mAmazonPrice_tax_excl.*mCounty_hh)./sumc(mCounty_hh);
  println("Population weighted average price: ");
  println("%c",{"year","avg. price","variety"},vYear'~vAvgPrice_tax_excl'~vVariety');
  
  decl mCounty_per_100=reshape(mSpendingComponents_mode1[][demand_perc_100],M,T);
  decl iCES_coef_int=unique(mSpendingComponents_mode1[][demand_tax_coeff]);
  decl iCES_coef_slope=unique(mSpendingComponents_mode1[][demand_tax_coeff100]);
  decl vNetwork_density_obs=reshape(mSpendingComponents_mode1[][demand_density1],M,T)[0][];
  iDensityParam=unique(mSpendingComponents_mode1[][demand_density_coeff]);
  println("iCES_coef_int: ",iCES_coef_int);
  println("iCES_coef_slope: ",iCES_coef_slope);
  decl max_inc_share=(1-iCES_coef_int)/iCES_coef_slope;
  println("max_inc_share: ",max_inc_share);
  mCES_param=1-iCES_coef_int-iCES_coef_slope.*setbounds(mCounty_per_100,0,max_inc_share);
  decl mAmazon_tax_obs=reshape(mDemoData[][demo_amazon_tax],M,T);
  println("Density parameter: ",iDensityParam);
  println("network density:: ",(vYear|vNetwork_density_obs)');
  /* Calculate input prices for each locations */
  vNearestCounty_id=mincindex(mDist_county_cluster);
  mCluster_wage=new matrix[N][T];
  mCluster_rent=new matrix[N][T];
  mCluster_density=new matrix[N][T];
  mDummy_cluster_county=zeros(N,M); /* Nb of cluster x Nb of counties */
  for(i=0;i<N;i++)
    {
      mDummy_cluster_county[i][vNearestCounty_id[i]]=1;
      mCluster_wage[i][]=mCounty_wage[vNearestCounty_id[i]][];
      mCluster_rent[i][]=mCounty_rent[vNearestCounty_id[i]][];
      mCluster_density[i][]=mCounty_density[vNearestCounty_id[i]][];      
    }      
  decl mCluster_density_ratio=mCluster_density./iAvgDensity;

  /****************************************************************************************************/
  /* Invariant characteristics */
  vFC_capacity=reshape(mFacilityData[][fc_sq_ft],nbFC,T)[][0];
  vFC_type=reshape(mFacilityData[][fc_typeid],nbFC,T)[][0];
  vDummy_sc=vFC_type.==type_sortation;
  vDummy_fc=(vFC_type.==type_sortable)+(vFC_type.==type_nonsortable);
  decl id_fc=vecindex(vDummy_fc,1);
  decl id_sc=vecindex(vDummy_sc,1);
  aID=new array[2];
  aID[0]=id_fc;
  aID[1]=id_sc;
  vFC_capacity[id_sc]=300000;
  vFC_capacity./=scale;

  /*************************************************************/
  /* Declare local variables */
  decl mFacilityData_swap,mFacilityData_swap0,mSimRevData,mFC_wage,mFC_rent,mFC_density,vFC_cluster;
  decl mOutput,vOutput_share,mLabor,mDistance,mAmazon_netrevenue,mAmazon_revenue;
  decl vAvgRent,vAvgWage,vAvgDensity,vNbFacilities;
  
  /*************************************************************/  
  println(aVarName_fc);
  decl var;
  decl vSwapid;
  decl vOutput,vLabor_cost,vLand_cost,vDensity_cost,vDensityCap_cost,mShipCost_variables,vRevenue,
    vNetRevenue,iHH_dist,iHH_vi,vHH_dist,vHH_vi,vHH_dist_nearest,vHH_vi_nearest,vHH_dist_vi,vHH_dist_vi_nearest,mHH_dist_demo,mHH_dist_demo_nearest,
    vAvgOrder_hh,mNetwork_distance,vNetwork_distance,vNetwork_density_distance,vNetwork_density_swap;
  decl mAmazon_tax,vAmazon_tax,mCounty_demand,aNetwork_combined,vMedianOrder_hh,vAvgNetRev_hh;
  decl mDummy_cluster,mDummy_fc_county,mFC_county_presence,vNetrev_order;
  decl vHH_taxable;
  decl iYear0,iYear1,dYear;
  decl iSwap_capacity;
  decl iSwap_type;
  decl iLocation0,iLocation1,dLocation;
  decl year;
  decl aVarName_list;
  decl mSwap_list=loadmat(sprint(swap_dir,"Swap_list.dta"),&aVarName_list);
  decl s,nbSwap=rows(mSwap_list);
  println("nb of Swaps: ",nbSwap);
  
  //decl s,nbSwap=1;
  decl time0;
  decl mSwapResults=new matrix[T*(1+nbSwap)][nbOutput_var];
  decl mSwapResults_diff=new matrix[(1+nbSwap)][nbOutput_var];
  decl vShipCost_param=new matrix[3][1]; vShipCost_param[0]=0; vShipCost_param[1]=0.3; vShipCost_param[2]=-0.3;
  decl vDiscounting=(0.95).^range(0,T-1);
  decl vParam_logistic_true=vParam_logistic;
  println("vDiscounting: ",vDiscounting);

  /* Swap 0 */
  mFacilityData_swap0=loadmat(sprint(swap_dir,"Facility_panel_swap0.dta"),&aVarName_fc);
  mFacilityData_swap0[][fc_sq_ft]./=scale;
  mFacilityData_swap0=sortbyc(mFacilityData_swap0,<fc_id,fc_year>);
  
  for(s=0;s<=nbSwap;s++)
    {
      time0=timer();
      println("///////////////////////////////////////////////////////");
      println("swap id: ",s);
      /* Load counter-factual revenue and network */
      mFacilityData_swap=loadmat(sprint(swap_dir,"Facility_panel_swap",s,".dta"),&aVarName_fc);
      mFacilityData_swap[][fc_sq_ft]./=scale;
      mFacilityData_swap=sortbyc(mFacilityData_swap,<fc_id,fc_year>);
      println("dim :",rows(mFacilityData_swap)~columns(mFacilityData_swap));
      println("%r",aVarName_fc,meanc(mFacilityData_swap)');
      println("%r",aVarName_fc,meanc(mFacilityData_swap0)');
      
      /* Characteristics of the swap */
      vSwapid=vecindex(sumr(fabs(mFacilityData_swap[][<fc_cluster_id,fc_oyear>].!=mFacilityData_swap0[][<fc_cluster_id,fc_oyear>])).>0,1);
      iYear0=minc(mFacilityData_swap0[vSwapid][fc_oyear]);
      iYear1=maxc(mFacilityData_swap[vSwapid][fc_oyear]);
      dYear=iYear1-iYear0;
      iLocation0=minc(mFacilityData_swap0[vSwapid][fc_cluster_id]);
      iLocation1=maxc(mFacilityData_swap[vSwapid][fc_cluster_id]);
      println("iLocations :",iLocation0~iLocation1);
      println("Location IDs: ",vecindex(vCluster_id,iLocation0)~vecindex(vCluster_id,iLocation1));
      dLocation=mDistance_cluster[vecindex(vCluster_id,iLocation0)][vecindex(vCluster_id,iLocation1)];
      println("dLocation : ",dLocation);
      if(s==0) {
	dLocation=0;
	dYear=0;
	iYear0=0;
	iYear1=0;
      }
      println("mFacility oyear: ",iYear0~iYear1~dYear);
      println("mFacility distance: ",dLocation);
      if(s==0) {
	iSwap_capacity=0;
	iSwap_type=0;
      }
      else {
	iSwap_capacity=unique(selectifr(mFacilityData_swap0[vSwapid][fc_sq_ft],mFacilityData_swap0[vSwapid][fc_oyear].==iYear1))
	  -unique(selectifr(mFacilityData_swap0[vSwapid][fc_sq_ft],mFacilityData_swap0[vSwapid][fc_oyear].==iYear0));
	iSwap_type=unique(selectifr(mFacilityData_swap0[vSwapid][fc_typeid],mFacilityData_swap0[vSwapid][fc_oyear].==iYear0));
      }
      println("Swap capacity and type: ",iSwap_capacity~iSwap_type);

      /* Reshape wide facility data: Activity and cost */
      vFC_id=reshape(mFacilityData_swap[][fc_id],nbFC,T)[][0];
      mFC_activity=reshape(mFacilityData_swap[][fc_dummy_active],nbFC,T);
      vFC_capacity=reshape(mFacilityData_swap[][fc_sq_ft],nbFC,T)[][0];
      vFC_type=reshape(mFacilityData_swap[][fc_typeid],nbFC,T)[][0];
      mFC_wage=reshape(mFacilityData_swap[][fc_imputed_wage],nbFC,T).*mFC_activity;
      mFC_rent=reshape(mFacilityData_swap[][fc_county_rent_dis_imputed],nbFC,T).*mFC_activity;
      mFC_density=reshape(mFacilityData_swap[][fc_pop_density],nbFC,T).*mFC_activity;
      vFC_cluster=reshape(mFacilityData_swap[][fc_cluster_id],nbFC,T)[][0];
      println("distribution of FC density ratio: ",quantilec(mFC_density[][T-1]/iAvgDensity,<0,1/4,1/2,3/4,1>)');

      /* Average input prices */
      vAvgWage=(sumc(mFC_wage[id_fc|id_sc][])./sumc(mFC_activity[id_fc|id_sc][]))';
      vAvgRent=(sumc(mFC_rent[id_fc|id_sc][])./sumc(mFC_activity[id_fc|id_sc][]))';
      vAvgDensity=(sumc(mFC_density[id_fc|id_sc][])./sumc(mFC_activity[id_fc|id_sc][]))';
      
      /* Indicator function classifying each regular fulfillment center in each cluster: (nb facility) x N) */
      mDummy_cluster=(vFC_cluster.==vCluster_id); /* nbFC x Nb cluster */
      vDummy_sc=vFC_type.==type_sortation;
      vDummy_fc=(vFC_type.==type_sortable)+(vFC_type.==type_nonsortable);
      id_fc=vecindex(vDummy_fc,1);
      id_sc=vecindex(vDummy_sc,1);
      aID=new array[2];
      aID[0]=id_fc;
      aID[1]=id_sc;
      vFC_capacity[id_sc]=300000/scale;
      println("distribution of capacity (FC): ",quantilec(vFC_capacity[id_fc],<0,1/4,1/2,3/4,1>)');
      println("distribution of capacity (SC): ",quantilec(vFC_capacity[id_sc],<0,1/4,1/2,3/4,1>)');

      /*******************************************************************************************************/
      /* Create year-by-year sortation and delivery network */
      iprint=0;
      sortation_network_mp(&aNetwork_combined,mDummy_cluster);
      
      /* HH-coverage: Network density measures */
      vHH_dist=new matrix[T][1];
      vHH_vi=new matrix[T][1];
      vHH_dist_vi=new matrix[T][1];
      mHH_dist_demo=new matrix[T][2];
      parallel for(year=0;year<T;year++)
	{
	  logistic_hh_coverage(&iHH_dist,&iHH_vi,aNetwork_combined,mDummy_cluster,year);
	  vHH_dist[year]=iHH_dist[0];
	  mHH_dist_demo[year][]=iHH_dist[2:];
	  vHH_dist_vi[year]=iHH_dist[1];
	  vHH_vi[year]=iHH_vi;
	}

      /* HH-coverage: Nearest FC */
      vParam_logistic[imu_0]=100;
      vHH_dist_nearest=new matrix[T][1];
      vHH_dist_vi_nearest=new matrix[T][1];
      vHH_vi_nearest=new matrix[T][1];
      mHH_dist_demo_nearest=new matrix[T][2];
      parallel for(year=0;year<T;year++)
	{
	  logistic_hh_coverage(&iHH_dist,&iHH_vi,aNetwork_combined,mDummy_cluster,year);
	  vHH_dist_nearest[year]=iHH_dist[0];
	  mHH_dist_demo_nearest[year][]=iHH_dist[2:];
	  vHH_dist_vi_nearest[year]=iHH_dist[1];
	  vHH_vi_nearest[year]=iHH_vi;
	}
      println("HH dist (nearest): ","%c",{"HH-dist","HH-VI","HH-dist-vi","HH-nearest"},vHH_dist~vHH_vi~vHH_dist_vi~vHH_dist_nearest);
      vNetwork_density_swap=vHH_dist_nearest';
      println("%c",{"year","nearest distance"},vYear'~vNetwork_density_swap');
      vParam_logistic[imu_0]=vParam_logistic_true[imu_0];

      /*******************************************************************************************************/	
      /* Compute taxes and spending by county */
      mDummy_fc_county=mDummy_cluster*mDummy_cluster_county; /* nb FC x nb Counties */
      mFC_county_presence=mDummy_fc_county[id_fc|id_sc][]'mFC_activity[id_fc|id_sc][]; /* Nb of active facilites per county */
      mFC_county_presence=(mFC_county_presence.>0);
 
      /* Compute Amazon tax */
      amazon_tax_func(&mAmazon_tax,mFC_county_presence);
      
      /* Compute spending */
      if(iConvenience==0) spending_func(&mAmazon_revenue,&mAmazon_netrevenue,&mCounty_demand,mAmazon_tax,vNetwork_density_obs);
      if(iConvenience==1) spending_func(&mAmazon_revenue,&mAmazon_netrevenue,&mCounty_demand,mAmazon_tax,vNetwork_density_swap);
      mCounty_demand=(mCounty_demand.*mCounty_hh);
      mAmazon_netrevenue.*=mCounty_hh;
      mAmazon_revenue.*=mCounty_hh;
      println("Avg orders and net revenue (/M): ","%c",{"spending","net-rev","orders"},
	      (sumc(mAmazon_revenue)|sumc(mAmazon_netrevenue)|sumc(mCounty_demand))'/scale);
      
      /* Aggregate demand characteristics across counties */
      vNetRevenue=sumc(mAmazon_netrevenue)';
      vHH_taxable=sumc((mAmazon_tax.>0).*mCounty_hh)';
      vAmazon_tax=(sumc(mAmazon_tax.*mCounty_hh)./sumc(mCounty_hh))';
      vAvgOrder_hh=meanc(mCounty_demand./mCounty_hh);
      vMedianOrder_hh=quantilec(mCounty_demand./mCounty_hh);
      vAvgNetRev_hh=meanc(mAmazon_netrevenue./mCounty_hh);
      vNetrev_order=sumc(mAmazon_netrevenue)./sumc(mCounty_demand);
      println("nb of orders and variety (in M) ","%c",{"year","demand","hh","avg order","median order","variety"},
	      (vYear|sumc(mCounty_demand/scale)|sumc(mCounty_hh/scale)|vAvgOrder_hh|vMedianOrder_hh|vVariety)');
      println("nb of orders and variety (in M) ","%cf",{"%9.0f"},"%c",{"year","revenue","demand","hh","net-rev","orders","med orders","netrev/order"},
	      (vYear|sumc(mAmazon_revenue/scale)|sumc(mCounty_demand/scale)|sumc(mCounty_hh/scale)|vAvgNetRev_hh|vAvgOrder_hh|vMedianOrder_hh|vNetrev_order)');
      
      /* Express orders in M units  */
      mCounty_demand./=scale;
      
      /*******************************************************************************************************/
      /* Output and cost components based on endogenous revenue */
      output_func_mp(&mOutput,&mLabor,&mDistance,&mNetwork_distance,aNetwork_combined,mDummy_cluster,mCounty_demand);
      mOutput.*=scale;
      mDistance.*=scale;
      println("distribution of employees per FC (2018): ",quantilec(selectifr(mLabor[id_fc][T-1],mFC_activity[id_fc][T-1].==1),<0,1/4,1/2,3/4,1>)');
      println("distribution of employees per SC (2018): ",quantilec(selectifr(mLabor[id_sc][T-1],mFC_activity[id_sc][T-1].==1),<0,1/4,1/2,3/4,1>)');
      
      /* Labor and land cost */
      vOutput=sumc(mOutput[id_fc][])';
      vLabor_cost=sumc(mLabor.*mFC_wage)';
      vLand_cost=sumc((vDummy_sc+vDummy_fc).*(vFC_capacity.*mFC_rent)*scale)';
      vDensityCap_cost=sumc((vDummy_fc+vDummy_fc).*(vFC_capacity.*mFC_density)*scale)';
      vDensity_cost=sumc((vDummy_fc+vDummy_fc).*mFC_density)';      
      vNetwork_distance=sumc(mNetwork_distance)';
      vNetwork_density_distance=sumc((mFC_density/iAvgDensity).*mNetwork_distance)';
      if(s==0) println("Operating cost components (Total/M): ","%c",{"net revenue","labor","rent","density-cap","density","network dist.","network density"},
		       ((vNetRevenue~vLabor_cost~vLand_cost~vDensityCap_cost~vDensity_cost)/scale)~vNetwork_distance~vNetwork_density_distance);

      /* Shipping cost */
      mShipCost_variables=new matrix[T][4];
      mShipCost_variables[][0]=sumc(mOutput[id_fc][])';
      mShipCost_variables[][1]=sumr(mDistance[][<2,3>])/100;
      mShipCost_variables[][2]=mDistance[][0];
      mShipCost_variables[][3]=mDistance[][2]/100;
      println("vShipCost_param: ",vShipCost_param);
      if(s==0) println("Average shipping cost components (Total/scale): ","%c",{"intercept","distance","VI (orders)","VI (distance)","Ship cost"},
		       (mShipCost_variables~(mShipCost_variables[][<0,1,2>]*vShipCost_param))/scale);
      if(s==0) println("Operating cost components (/order): ","%c",{"net-revenue","labor","rent","density"},(vNetRevenue~vLabor_cost~vLand_cost~vDensityCap_cost)./vOutput);
      if(s==0) println("Average shipping cost components (/order): ","%c",
		       {"intercept","distance","VI (orders)","VI (distance)","Ship cost"},(mShipCost_variables~(mShipCost_variables[][:2]*vShipCost_param))./vOutput);
     

      /* Group variables in matrix */
      mSwapResults[s*T:(s+1)*T-1][out_swapid]=constant(s,T,1);
      mSwapResults[s*T:(s+1)*T-1][out_year]=vYear';
      mSwapResults[s*T:(s+1)*T-1][out_net_revenue]=vNetRevenue/scale;
      mSwapResults[s*T:(s+1)*T-1][out_labor_cost]=vLabor_cost/scale;
      mSwapResults[s*T:(s+1)*T-1][out_land_cost]=vLand_cost/scale;
      mSwapResults[s*T:(s+1)*T-1][out_density_cap]=(vDensityCap_cost/scale)/100;
      mSwapResults[s*T:(s+1)*T-1][out_density]=(vDensity_cost)/100;
      mSwapResults[s*T:(s+1)*T-1][out_network_distance]=vNetwork_distance;
      mSwapResults[s*T:(s+1)*T-1][out_network_density]=vNetwork_density_distance;
      mSwapResults[s*T:(s+1)*T-1][out_ship_int]=mShipCost_variables[][0]/scale;
      mSwapResults[s*T:(s+1)*T-1][out_ship_dist]=(mShipCost_variables[][1]/scale);
      mSwapResults[s*T:(s+1)*T-1][out_ship_vi]=mShipCost_variables[][2]/scale;
      mSwapResults[s*T:(s+1)*T-1][out_ship_vi_dist]=(mShipCost_variables[][3]/scale);
      mSwapResults[s*T:(s+1)*T-1][out_avg_wage]=vAvgWage;
      mSwapResults[s*T:(s+1)*T-1][out_avg_rent]=vAvgRent;
      mSwapResults[s*T:(s+1)*T-1][out_avg_density]=vAvgDensity;
      mSwapResults[s*T:(s+1)*T-1][out_hh_dist]=vHH_dist;
      mSwapResults[s*T:(s+1)*T-1][out_hh_dist_vi]=vHH_dist_vi;
      mSwapResults[s*T:(s+1)*T-1][out_hh_vi]=vHH_vi;
      mSwapResults[s*T:(s+1)*T-1][out_inc_dist]=mHH_dist_demo[][0];
      mSwapResults[s*T:(s+1)*T-1][out_young_dist]=mHH_dist_demo[][1];  
      mSwapResults[s*T:(s+1)*T-1][out_hh_dist_nearest]=vHH_dist_nearest;
      mSwapResults[s*T:(s+1)*T-1][out_hh_dist_vi_nearest]=vHH_dist_vi_nearest;
      mSwapResults[s*T:(s+1)*T-1][out_hh_vi_nearest]=vHH_vi_nearest;
      mSwapResults[s*T:(s+1)*T-1][out_inc_dist_nearest]=mHH_dist_demo_nearest[][0];
      mSwapResults[s*T:(s+1)*T-1][out_young_dist_nearest]=mHH_dist_demo_nearest[][1];
      mSwapResults[s*T:(s+1)*T-1][out_swap_year0]=constant(iYear0,T,1);
      mSwapResults[s*T:(s+1)*T-1][out_swap_dyear]=constant(dYear,T,1);
      mSwapResults[s*T:(s+1)*T-1][out_swap_distance]=constant(dLocation,T,1);
      mSwapResults[s*T:(s+1)*T-1][out_swap_capacity]=constant(iSwap_capacity,T,1);
      mSwapResults[s*T:(s+1)*T-1][out_swap_type]=constant(iSwap_type,T,1);
      mSwapResults[s*T:(s+1)*T-1][out_tax_avg]=vAmazon_tax;
      mSwapResults[s*T:(s+1)*T-1][out_tax_hh]=vHH_taxable;            
      if(s==0) println("Cost components (endogenous)","%r",aOutput_varname,mSwapResults[s*T:(s+1)*T-1][]');
      
      /* Express results in difference between option 0 and rejected options */
      mSwapResults_diff[s][out_swapid]=s;
      mSwapResults_diff[s][out_year]=1999;
      if(s>0) {
	for(var=2;var<nbOutput_var;var++) mSwapResults_diff[s][var]=vDiscounting*(mSwapResults[0:T-1][var]-mSwapResults[s*T:(s+1)*T-1][var]);
      }
      if(s==0) {
	for(var=2;var<nbOutput_var;var++) mSwapResults_diff[s][var]=vDiscounting*(mSwapResults[0:T-1][var]);
      }      
      mSwapResults_diff[s][out_swap_year0]=iYear0;
      mSwapResults_diff[s][out_swap_dyear]=dYear;
      mSwapResults_diff[s][out_swap_distance]=dLocation;
      mSwapResults_diff[s][out_swap_capacity]=iSwap_capacity;
      mSwapResults_diff[s][out_swap_type]=iSwap_type;

      println("Difference in cost components (endogneous)"); 
      println("%r",aOutput_varname,mSwapResults_diff[s][]');
      println("cpu time: ",(timer()-time0)/100);

    }

  if(nbSwap>2){
    if(iConvenience==1) {
      savemat(sprint(swap_dir,"Swap_components_convenience_taxdelay",iTaxDelay,"_",iEstimator,"_variety",iVariety,"_demandspec",demand_spec,".dta"),mSwapResults,aOutput_varname);
      savemat(sprint(swap_dir,"Swap_diff_components_convenience_taxdelay",iTaxDelay,"_",iEstimator,"_variety",iVariety,"_demandspec",demand_spec,".dta"),mSwapResults_diff,aOutput_varname);
      savemat(sprint(swap_dir,"Swap_components_convenience_taxdelay",iTaxDelay,"_",iEstimator,"_variety",iVariety,"_demandspec",demand_spec,".in7"),mSwapResults,aOutput_varname);
      savemat(sprint(swap_dir,"Swap_diff_components_convenience_taxdelay",iTaxDelay,"_",iEstimator,"_variety",iVariety,"_demandspec",demand_spec,".in7"),mSwapResults_diff,aOutput_varname);
    }
    if(iConvenience==0) {
      savemat(sprint(swap_dir,"Swap_components_taxdelay",iTaxDelay,"_",iEstimator,"_variety",iVariety,"_demandspec",demand_spec,".dta"),mSwapResults,aOutput_varname);
      savemat(sprint(swap_dir,"Swap_diff_components_taxdelay",iTaxDelay,"_",iEstimator,"_variety",iVariety,"_demandspec",demand_spec,".dta"),mSwapResults_diff,aOutput_varname);
      savemat(sprint(swap_dir,"Swap_components_taxdelay",iTaxDelay,"_",iEstimator,"_variety",iVariety,"_demandspec",demand_spec,".in7"),mSwapResults,aOutput_varname);
      savemat(sprint(swap_dir,"Swap_diff_components_taxdelay",iTaxDelay,"_",iEstimator,"_variety",iVariety,"_demandspec",demand_spec,".in7"),mSwapResults_diff,aOutput_varname);
    }    
  }
  
}

/* Run swap function for alternative specification combinations */
main()
{
  decl demand_spec;
  for(demand_spec=1;demand_spec<=4;demand_spec++)
    {
      for(iVariety=0;iVariety<2;iVariety++)
	{
	  /* Specification GMM */
	  iTaxDelay=2;
	  iConvenience=0;
	  iLargeCES=0;
	  iEstimator="GMM";
	  swap_value(demand_spec);

	  /* Specification NLS */
	  iTaxDelay=2;
	  iConvenience=0;
	  iLargeCES=0;
	  iEstimator="NLS";
	  swap_value(demand_spec);
	}
    }
 
}