/********************************************************************************************************/
moment_func(const avR, const vP)  
{
  /* Update Parameter vector */
  vParam_logistic[vOPTid]=vP;
  /* Predicted output and labor demand */
  decl mOutput_pred,mLabor_pred,mDist_pred,mNetwork_dist;
  output_func_mp(&mOutput_pred,&mLabor_pred,&mDist_pred,&mNetwork_dist,aNetwork_combined,mDummy_cluster,mCounty_demand);
  
  /* Total Employment */
  decl vTotal_emp_pred=sumc(mLabor_pred)/1000; 
  decl vResid_total=(log(vTotal_emp_pred[:T-2])'-log(vTotal_emp[:T-2])')./vSE_total[:T-2];
  decl SSR_total=sumsqrc(vResid_total);
  if(iprint) println("vTotal_empl: ",(vYear|vTotal_emp|vTotal_emp_pred)');
  if(iprint) println("SSR: ",SSR_total);

  /* Aggregate employment trend regression: Match slope and end-point  */
  decl vTrend_coef_aux;
  decl vY=log(vTotal_emp_pred[:T-2])-meanr(log(vTotal_emp_pred[:T-2]));
  olsr(vY,mCharact_trend,&vTrend_coef_aux);
  if(iprint) println("auliliary trend regression: ",vTrend_coef_aux);
  decl vTrend_resid=((vTrend_coef-vTrend_coef_aux)~(log(vTotal_emp_pred[T-2])-log(vTotal_emp[T-2])))';
  if(iprint) println("%r",{"Pred","Obs"},"%c",{"slopes"},((vTrend_coef|vTrend_coef_aux)));
  if(iprint) println("%r",{"Pred","Obs"},"%c",{"2017"},log(vTotal_emp_pred[T-2])|log(vTotal_emp[T-2]));
	        
  /* Establishment-level employment */
  decl i,id;
  decl vAvgLabor_pred=mLabor_pred[][T-2].*mFC_activity[][T-2];
  decl vLogEmpl_pred=log(vAvgLabor_pred[mID_empl[][0]]);

  /* Auxliary regression */
  decl vBeta_aux;
  olsc(vLogEmpl_pred,mCharact,&vBeta_aux);

  /* Calculation of standard errors  */
  decl vResid=vLogEmpl_pred-mCharact*vBeta_aux;
  decl mV_ols=invert(mCharact'mCharact)*((mCharact.*(vResid.^2))'mCharact)*invert(mCharact'mCharact);
  decl vSE_ols=sqrt(diagonal(mV_ols)');

  if(iprint) println("%r",aCoef_name,"%c",{"Data","Model"},vBeta~vBeta_aux~vSE_ols);
    
  decl vIE_resid=(vBeta-vBeta_aux);
  if(iprint) println("SSR aggregate moments: ",SSR_total);
  if(iprint) println("SSR IE moments:",sumsqrc(vIE_resid));
  decl vMoment_combined=(vIE_resid|vTrend_resid);
  if(iprint) println("Combined residual: ",vMoment_combined);
  avR[0]=vMoment_combined;
  return 1;
}
resid_func(const avR, const vP)
{
  /* Update Parameter vector */
  vParam_logistic[vOPTid]=vP;
  /* Predicted output and labor demand */
  decl mOutput_pred,mLabor_pred,mDist_pred,mNetwork_dist;  
  output_func_mp(&mOutput_pred,&mLabor_pred,&mDist_pred,&mNetwork_dist,aNetwork_combined,mDummy_cluster,mCounty_demand);

  /* Total Employment */
  decl vTotal_emp_pred=sumc(mLabor_pred)/1000; 
  decl vResid_log_total=(log(vTotal_emp_pred[:T-2])'-log(vTotal_emp[:T-2])');
  //decl vResid_log_total=(log(vTotal_emp_pred[T-2])'-log(vTotal_emp[T-2])');
  decl vResid_level_total=((vTotal_emp_pred[T-2])'-(vTotal_emp[T-2])');

  /* Establishment-level employment */
  decl vLabor_2018=mLabor_pred[][T-2];
  decl i,id;
  decl vLogEmpl_pred=log(vLabor_2018[mID_empl[][0]]);
  avR[0]=(log(vLabor_2018[mID_empl[][0]])-vLogEmpl_obs)|(vResid_log_total);
  //avR[0]=(((vLabor_2018[mID_empl[][0]])-exp(vLogEmpl_obs))|(vResid_level_total))/1000;
  return 1;
}
/********************************************************************************************************/
gmm_func(const vP, const adFunc, const avScore, const amHessian)
{
  decl vResid;
  moment_func(&vResid,vP);
  adFunc[0]=double(-vResid[vMoment_id]'mWeight[vMoment_id][vMoment_id]*vResid[vMoment_id]);  
  return 1;
}
/********************************************************************************************************/
nls_func(const vP, const adFunc, const avScore, const amHessian)
{
  decl vResid;
  resid_func(&vResid,vP);
  adFunc[0]=double(-sumsqrc(vResid));
  return 1;
}
  

