/* Matching probability function */
match_prob(aFunc,const vActive_id,const vMu)
{
  decl M=rows(mDist_county_cluster);
  decl N=columns(mDist_county_cluster);
  decl n=rows(vActive_id);
  decl mMu=ones(M,N).*vMu';
  decl mMatchProb=new matrix[M][N]; /* Match probability matrix (columns = cluster id) */
  decl mDummy_lower,mDummy_higher;
  decl id_lower,id;
  decl j;
  if(vParam_logistic[imu_0]==100) {
    decl vNearestCluster=mincindex(mDist_county_cluster[][vActive_id]');
    for(j=0;j<M;j++) mMatchProb[j][vActive_id[vNearestCluster[j]]]=1;
  }
  else {
    for(j=0;j<n;j++)
      {
	mDummy_lower=mDist_county_cluster[][vActive_id].<mDist_county_cluster[][vActive_id[j]];
	mDummy_higher=1-mDummy_lower;
	mMatchProb[][vActive_id[j]]=vMu[vActive_id[j]].*prodr((1-vMu[vActive_id]').*mDummy_lower+mDummy_higher);
      }
    mMatchProb./=sumr(mMatchProb);
  }
  aFunc[0]=mMatchProb;
  return 1;
}
/********************************************************************************************************************************************************/
sortation_network_mp(const aNetwork_combined,const mDummy_cluster)
{
  /* Type IDs */
  decl vActive_cluster_fc,vActive_cluster_sc;
  decl mActive_sortation;
  decl mDist_fc_sort;
  decl mDist_county_sc=mDist_county_cluster*mDummy_cluster';
  decl year;
  decl i,id,id0,id_fc,id_sc;
  /* Initial network */
  decl aNetwork_sortation,aSortation_zone,aDist_fc_sc;    
  aNetwork_sortation=new array[T];
  aSortation_zone=new array[T];
  aDist_fc_sc=new array[T];  
  /* Update network */
  decl vOneid;  
  decl mDist_facilities=mDummy_cluster*mDistance_cluster*mDummy_cluster';
  decl mNetwork_cluster,vDistance_network_sc;
  parallel for(year=0;year<T;year++)    
    {
      /* Determine the set of FCs associated with each SC */
      id_fc=selectifr(aID[0],mFC_activity[aID[0]][year].==1);
      id_sc=selectifr(aID[1],mFC_activity[aID[1]][year].==1);
      vActive_cluster_fc=vecindex(sumc(mDummy_cluster[id_fc][]).>0,1);
      vActive_cluster_sc=vecindex(sumc(mDummy_cluster[id_sc][]).>0,1);
      /* Set = closest FC + FCs within iFCThreshold miles: Nb FC x Nb SC */
      mNetwork_cluster=setbounds((mDistance_cluster[vActive_cluster_fc][vActive_cluster_sc].<iFCThreshold)
				 +(mDistance_cluster[vActive_cluster_fc][vActive_cluster_sc].==minc(mDistance_cluster[vActive_cluster_fc][vActive_cluster_sc])),0,1);
      vDistance_network_sc=((sumc(mNetwork_cluster.*mDistance_cluster[vActive_cluster_fc][vActive_cluster_sc])
			     ./setbounds(sumc(mNetwork_cluster),1,M_INF_POS))*mDummy_cluster[id_sc][vActive_cluster_sc]')';
      aNetwork_sortation[year]=mDummy_cluster[id_fc][vActive_cluster_fc]*mNetwork_cluster*mDummy_cluster[id_sc][vActive_cluster_sc]';
      //aDist_fc_sc[year]=mDist_facilities[id_fc][id_sc];
      aDist_fc_sc[year]=vDistance_network_sc;
      if(vActive_cluster_sc!=<>) {
	if(iprint) println("//////////////////////////////////////////////////");
	if(iprint) println("year: ",vYear[year],"%r",
			   {"nb of FCs per SC"},"%c",{"min","25","50","75","max"},quantiler(sumc(aNetwork_sortation[year]),<0,1/4,1/2,3/4,1>));
	if(iprint) println("year: ",vYear[year],"%r",{"Capacity weighted distance between SF-FC"},"%c",{"min","25","50","75","max"},quantiler(sumc(mDist_facilities[id_fc][id_sc].*aNetwork_sortation[year].*vFC_capacity[id_fc])
											    ./sumc(aNetwork_sortation[year].*vFC_capacity[id_fc]),<0,1/4,1/2,3/4,1>));
	if(iprint) println("year: ",vYear[year],"%r",{"Avg. distance between SF-FC"},"%c",{"min","25","50","75","max"},quantiler(sumc(mDist_facilities[id_fc][id_sc].*aNetwork_sortation[year])
																 ./sumc(aNetwork_sortation[year]),<0,1/4,1/2,3/4,1>));
      }
      /* Downstream network */
      aSortation_zone[year]=zeros(M,nbFC);
      (aSortation_zone[year])[][id_sc]=(mDist_county_sc[][id_sc].<iSortThreshold);
      vOneid=vecindex(sumr(aSortation_zone[year]).>1,1);
      if(vOneid!=<>) {
	(aSortation_zone[year])[vOneid][id_sc].*=exp(-mDist_county_sc[vOneid][id_sc]);
	(aSortation_zone[year])[vOneid][id_sc]./=sumr((aSortation_zone[year])[vOneid][id_sc]);
      }
      if(vActive_cluster_sc!=<>) {
	if(iprint) println("year: ",vYear[year]," HH covered by a SC: ",(sumc(sumr(aSortation_zone[year]).*mCounty_hh[][year])./sumc(mCounty_hh[][year]))[0]);
	if(iprint) println("year: ",vYear[year]," Fraction of counties covered by a SC: ",meanc(sumr(aSortation_zone[year]))[0]);
      }
    }
  decl aNetwork=new array[3];
  aNetwork[iNetwork_sortation]=aNetwork_sortation;
  aNetwork[iSortation_zone]=aSortation_zone;
  aNetwork[iDist_fc_sc]=aDist_fc_sc;
  aNetwork_combined[0]=aNetwork;
  return 1;
}
sortation_network_serial(const aNetwork_combined,const mDummy_cluster)
{
  /* Type IDs */
  decl vActive_cluster_fc,vActive_cluster_sc;
  decl mActive_sortation;
  decl mDist_fc_sort;
  decl mDist_county_sc=mDist_county_cluster*mDummy_cluster';
  decl year;
  decl i,id,id0,id_fc,id_sc;
  /* Initial network */
  decl aNetwork_sortation,aSortation_zone,aDist_fc_sc;    
  aNetwork_sortation=new array[T];
  aSortation_zone=new array[T];
  aDist_fc_sc=new array[T];
  /* Update network */
  decl vOneid;
  decl mDist_facilities=mDummy_cluster*mDistance_cluster*mDummy_cluster';
  decl mNetwork_cluster,vDistance_network_sc;
  for(year=0;year<T;year++)
    {
      /* Determine the set of FCs associated with each SC */
      id_fc=selectifr(aID[0],mFC_activity[aID[0]][year].==1);
      id_sc=selectifr(aID[1],mFC_activity[aID[1]][year].==1);
      vActive_cluster_fc=vecindex(sumc(mDummy_cluster[id_fc][]).>0,1);
      vActive_cluster_sc=vecindex(sumc(mDummy_cluster[id_sc][]).>0,1);
      /* Set = closest FC + FCs within iFCThreshold miles: Nb FC x Nb SC */
      mNetwork_cluster=setbounds((mDistance_cluster[vActive_cluster_fc][vActive_cluster_sc].<iFCThreshold)
				 +(mDistance_cluster[vActive_cluster_fc][vActive_cluster_sc].==minc(mDistance_cluster[vActive_cluster_fc][vActive_cluster_sc])),0,1);      
      vDistance_network_sc=(sumc(mNetwork_cluster.*mDistance_cluster[vActive_cluster_fc][vActive_cluster_sc])
			    ./setbounds(sumc(mNetwork_cluster),1,M_INF_POS))*mDummy_cluster[id_sc][vActive_cluster_sc]';
      aNetwork_sortation[year]=mDummy_cluster[id_fc][vActive_cluster_fc]*mNetwork_cluster*mDummy_cluster[id_sc][vActive_cluster_sc]';
      aDist_fc_sc[year]=vDistance_network_sc;
      if(vActive_cluster_sc!=<>) {
	if(iprint) println("//////////////////////////////////////////////////");
	if(iprint) println("year: ",vYear[year],"%r",
			   {"nb of FCs per SC"},"%c",{"min","25","50","75","max"},quantiler(sumc(aNetwork_sortation[year]),<0,1/4,1/2,3/4,1>));
	if(iprint) println("year: ",vYear[year],"%r",{"Capacity weighted distance between SF-FC"},"%c",{"min","25","50","75","max"},quantiler(sumc(mDist_facilities[id_fc][id_sc].*aNetwork_sortation[year].*vFC_capacity[id_fc])
											    ./sumc(aNetwork_sortation[year].*vFC_capacity[id_fc]),<0,1/4,1/2,3/4,1>));
	if(iprint) println("year: ",vYear[year],"%r",{"Avg. distance between SF-FC"},"%c",{"min","25","50","75","max"},quantiler(sumc(mDist_facilities[id_fc][id_sc].*aNetwork_sortation[year])
											    ./sumc(aNetwork_sortation[year]),<0,1/4,1/2,3/4,1>));
      }
      /* Downstream network */
      aSortation_zone[year]=zeros(M,nbFC);
      (aSortation_zone[year])[][id_sc]=(mDist_county_sc[][id_sc].<iSortThreshold);
      vOneid=vecindex(sumr(aSortation_zone[year]).>1,1);
      if(vOneid!=<>) {
	(aSortation_zone[year])[vOneid][id_sc].*=exp(-mDist_county_sc[vOneid][id_sc]);
	(aSortation_zone[year])[vOneid][id_sc]./=sumr((aSortation_zone[year])[vOneid][id_sc]);
      }
      if(vActive_cluster_sc!=<>) {
	if(iprint) println("year: ",vYear[year]," HH covered by a SC: ",(sumc(sumr(aSortation_zone[year]).*mCounty_hh[][year])./sumc(mCounty_hh[][year]))[0]);
	if(iprint) println("year: ",vYear[year]," Fraction of counties covered by a SC: ",meanc(sumr(aSortation_zone[year]))[0]);
      }
    }
  decl aNetwork=new array[3];
  aNetwork[iNetwork_sortation]=aNetwork_sortation;
  aNetwork[iSortation_zone]=aSortation_zone;
  aNetwork[iDist_fc_sc]=aDist_fc_sc;
  aNetwork_combined[0]=aNetwork;
  return 1;  
}
/********************************************************************************************************************************************************/
/* Logistic model: Match probability and output functions */
logistic_output_func(aOutput,aDist,aDistance_network,aMatchProb,const aNetwork_combined,const mDummy_cluster,const mCounty_demand,const aActiveID,const year)
{
  decl i;
  /* Sortation network */
  decl aNetwork_sortation,aSortation_zone,aDist_fc_sc;    
  aNetwork_sortation=aNetwork_combined[iNetwork_sortation];
  aSortation_zone=aNetwork_combined[iSortation_zone];
  aDist_fc_sc=aNetwork_combined[iDist_fc_sc]; 
  /* Row IDs of active facilities */
  decl id_fc=aActiveID[0];
  decl id_sc=aActiveID[1];
  /* Demand */
  decl vQ=mCounty_demand[][year];
  /* Capacity of clusters: NxJ */
  decl theta;
  if(iVariety) {
    theta=vParam_logistic[imu_0]/(vVariety[year]);
  }
  else {
    theta=vParam_logistic[imu_0];
  }
  decl vSumCapacity=mDummy_cluster[id_fc][]'vFC_capacity[id_fc]; /* Sum capacity of active FCs */
  decl vActive_cluster_fc=vecindex(vSumCapacity.>0,1); /* Active cluster ID */
  decl mOutput_share=(vFC_capacity[id_fc].*mDummy_cluster[id_fc][vActive_cluster_fc])./(vSumCapacity[vActive_cluster_fc]');
  decl vMu=zeros(N,1);
  vMu[vActive_cluster_fc]=1-exp(-theta.*vSumCapacity[vActive_cluster_fc]);
  decl n=rows(vActive_cluster_fc);
  if(iprint) println("Year: ",vYear[year]);
  if(iprint) println("nb of active active clusters: ",n);
  if(iprint) println("nb of active active facilities: ",rows(id_fc));
  if(iprint) println("%r",{"mean","min","25","50","75","Max"},"%c",{"Nb FCs","K","mu"},
		     meanc((sumc(mDummy_cluster[id_fc][])'~vSumCapacity~vMu)[vActive_cluster_fc][])|
		     quantilec((sumc(mDummy_cluster[id_fc][])'~vSumCapacity~vMu)[vActive_cluster_fc][],<0,1/4,0.5,3/4,1>));
  
  /* Matching probability */
  decl mMatchProb;
  match_prob(&mMatchProb,vActive_cluster_fc,vMu);
  
  /* Output: FC */
  decl mMatchProb_fc=(mMatchProb[][vActive_cluster_fc]*mOutput_share'); /* Dimension: Nb Counties x nb FC */
  decl vOutput_fc=mMatchProb_fc'vQ;
  
  if(iprint) println("%r",{"distribution of FC output: "},meanc(vOutput_fc)~quantilec(vOutput_fc,<0,1/4,1/2,3/4,1>)');

  /* Output: SC */
  /* Sum across counties of volume potentially transiting through each sortation facility: Nb. Active FC x Nb SC */
  decl mOrder_fc_sc=(vQ.*mMatchProb_fc)'(aSortation_zone[year])[][id_sc]; 
  decl vOutput_sc=sumc(aNetwork_sortation[year].*mOrder_fc_sc)';
  if(iprint) if(id_sc!=<>) println("%r",{"distribution of SC output: "},meanc(vOutput_sc)~quantilec(vOutput_sc,<0,1/4,1/2,3/4,1>)');
  
  /* Stack ouptut vector */
  decl vOutput=zeros(nbFC,1);
  vOutput[id_fc]=vOutput_fc;
  vOutput[id_sc]=vOutput_sc;
    
  /* Sortation Network */
  /* Indicator variable equal to one with a county and FCs are connected: Nb Counties x Nb of Active FC */
  decl mSortationNetwork;
  if(id_sc==<>) {
    mSortationNetwork=zeros(M,1);
  }
  else mSortationNetwork=setbounds((aSortation_zone[year])[][id_sc]*aNetwork_sortation[year]',0,1);
  decl vDistance_network=new matrix[nbFC][1];
  if(id_sc!=<>) vDistance_network[id_sc]=aDist_fc_sc[year]+iMinDist;
  
  /* Distance */
  decl mOutput_vi=vQ.*mMatchProb_fc.*mSortationNetwork;
  decl mOutput_out=vQ.*mMatchProb_fc.*(1-mSortationNetwork);
  decl vOutput_vi=sumc(mOutput_vi)';
  decl vOutput_out=sumc(mOutput_out)';  
  decl mDistFunc_fc=(vQ.*mMatchProb[][vActive_cluster_fc].*mDist_county_cluster[][vActive_cluster_fc])*mOutput_share';  
  decl vDist_vi=sumc(mDistFunc_fc.*mSortationNetwork)'; /* Aggregate distance across all integrated shipments */
  decl vDist_out=sumc(mDistFunc_fc.*(1-mSortationNetwork))'; /* Aggregate distance across all third-party shipments */
  if(iprint) println("%r",{"Volume-weighted average distance: "},"%c",{"vi","non-vi"},(sumc(vDist_vi)/sumc(vOutput_vi))~sumc(vDist_out)/sumc(vOutput_out));
  if(iprint) println("fraction of VI orders: ",sumc(vOutput_vi)./sumc(vOutput_fc));
  
  /* Store results */
  aOutput[0]=vOutput;
  aDist[0]=(vOutput_vi~vOutput_out~vDist_vi~vDist_out);
  aDistance_network[0]=vDistance_network;  
  aMatchProb[0]=mMatchProb;
  return 1;
}
/********************************************************************************************************/
/* Labor demand and output functions */
output_func_mp(aOutput,aLabor,aDist,aNetwork_dist,const aNetwork_combined,const mDummy_cluster,const mCounty_demand)
{
  /* Output and Labor demand function */
  decl vOutput,vHH_sc;
  decl time0=timer();
  decl mOutput=new matrix[nbFC][T];
  decl mNetwork_distance=new matrix[nbFC][T];
  decl mLabor=new matrix[nbFC][T];
  decl mHH_sc=new matrix[M][T];
  decl mDist=new matrix[T][4];
  decl mDist_t,mMatchProb_t,vDistance_network_t;
  decl aActiveID;
  decl year;
  decl id_fc,id_sc;
  parallel for(year=0;year<T;year++)
    {
      if(iprint) println("//////////////////////////");
      if(iprint) println("year: ",vYear[year]);
      id_fc=selectifr(aID[0],mFC_activity[aID[0]][year].==1);
      id_sc=selectifr(aID[1],mFC_activity[aID[1]][year].==1);
      aActiveID=new array[2];
      aActiveID[0]=id_fc;
      aActiveID[1]=id_sc;
      /* Logistic model: Facility output */
      logistic_output_func(&vOutput,&mDist_t,&vDistance_network_t,&mMatchProb_t,aNetwork_combined,mDummy_cluster,mCounty_demand,aActiveID,year); 
      mLabor[id_sc][year]=100*(vParam_logistic[iAsc]).*(vOutput[id_sc].^vParam_logistic[ialpha]);
      mLabor[id_fc][year]=100*(vParam_logistic[iAfc]).*(vOutput[id_fc].^vParam_logistic[ialpha]);           
      /* Prints */
      if(iprint) println("%r",{"distribution of FC labor: "},meanc(mLabor[id_fc][year])~quantilec(mLabor[id_fc][year],<0,1/4,1/2,3/4,1>)');
      if(iprint) if(id_sc!=<>) println("%r",{"distribution of SC labor: "},meanc(mLabor[id_sc][year])~quantilec(mLabor[id_sc][year],<0,1/4,1/2,3/4,1>)');      
      /* Store results */
      mOutput[][year]=vOutput;
      mDist[year][]=sumc(mDist_t);
      mNetwork_distance[][year]=vDistance_network_t;
    }
  aOutput[0]=mOutput;
  aLabor[0]=mLabor;
  aDist[0]=mDist;
  aNetwork_dist[0]=mNetwork_distance;
  return 1;
}
output_func_serial(aOutput,aLabor,aDist,aNetwork_dist,const aNetwork_combined,const mDummy_cluster,const mCounty_demand)
{
  /* Output and Labor demand function */
  decl vOutput,vHH_sc;
  decl time0=timer();
  decl mOutput=new matrix[nbFC][T];
  decl mNetwork_distance=new matrix[nbFC][T];
  decl mLabor=new matrix[nbFC][T];
  decl mHH_sc=new matrix[M][T];
  decl mDist=new matrix[T][4];
  decl mDist_t,mMatchProb_t,vDistance_network_t;
  decl aActiveID;
  decl year;
  decl id_fc,id_sc;
  for(year=0;year<T;year++)
    {
      if(iprint) println("//////////////////////////");
      if(iprint) println("year: ",vYear[year]);
      id_fc=selectifr(aID[0],mFC_activity[aID[0]][year].==1);
      id_sc=selectifr(aID[1],mFC_activity[aID[1]][year].==1);
      aActiveID=new array[2];
      aActiveID[0]=id_fc;
      aActiveID[1]=id_sc;
      /* Logistic model: Facility output */
      logistic_output_func(&vOutput,&mDist_t,&vDistance_network_t,&mMatchProb_t,aNetwork_combined,mDummy_cluster,mCounty_demand,aActiveID,year); 
      mLabor[id_sc][year]=100*(vParam_logistic[iAsc]).*(vOutput[id_sc].^vParam_logistic[ialpha]);
      mLabor[id_fc][year]=100*(vParam_logistic[iAfc]).*(vOutput[id_fc].^vParam_logistic[ialpha]);           
      /* Prints */
      if(iprint) println("%r",{"distribution of FC labor: "},meanc(mLabor[id_fc][year])~quantilec(mLabor[id_fc][year],<0,1/4,1/2,3/4,1>)');
      if(iprint) if(id_sc!=<>) println("%r",{"distribution of SC labor: "},meanc(mLabor[id_sc][year])~quantilec(mLabor[id_sc][year],<0,1/4,1/2,3/4,1>)');      
      /* Store results */
      mOutput[][year]=vOutput;
      mDist[year][]=sumc(mDist_t[][:3]);
      mNetwork_distance[][year]=vDistance_network_t;	     
    }
  aOutput[0]=mOutput;
  aLabor[0]=mLabor;
  aDist[0]=mDist;
  aNetwork_dist[0]=mNetwork_distance;  
  return 1;
}
/********************************************************************************************************************************************************/
/* Logistic model: HH weighted distance */
logistic_hh_coverage(aHH_dist,aHH_vi,const aNetwork_combined,const mDummy_cluster,const year)
{
  /* Row IDs of active facilities */
  decl i;
  decl id_fc=selectifr(aID[0],mFC_activity[aID[0]][year].==1);
  decl id_sc=selectifr(aID[1],mFC_activity[aID[1]][year].==1);
  /* Capacity of clusters: NxJ */
  decl theta;
  if(iVariety) {
    theta=vParam_logistic[imu_0]/(vVariety[year]);
  }
  else {
    theta=vParam_logistic[imu_0];
  }
  decl vSumCapacity=mDummy_cluster[id_fc][]'vFC_capacity[id_fc]; /* Sum capacity of active FCs */
  decl vActive_cluster_fc=vecindex(vSumCapacity.>0,1); /* Active cluster ID */
  decl mOutput_share=(vFC_capacity[id_fc].*mDummy_cluster[id_fc][vActive_cluster_fc])./(vSumCapacity[vActive_cluster_fc]');
  decl vMu=zeros(N,1);
  vMu[vActive_cluster_fc]=1-exp(-theta.*vSumCapacity[vActive_cluster_fc]);
  decl n=rows(vActive_cluster_fc);
  if(iprint) println("year: " ,vYear[year]);
  if(iprint) println("nb of active active clusters: ",n);
  if(iprint) println("nb of active active facilities: ",rows(id_fc));
  if(iprint) println("%r",{"mean","min","25","50","75","Max"},"%c",{"Nb FCs","K","mu"},
  meanc((sumc(mDummy_cluster[id_fc][])'~vSumCapacity~vMu)[vActive_cluster_fc][])|
  quantilec((sumc(mDummy_cluster[id_fc][])'~vSumCapacity~vMu)[vActive_cluster_fc][],<0,1/4,0.5,3/4,1>));
  
  /* Matching probability */
  decl mMatchProb;
  match_prob(&mMatchProb,vActive_cluster_fc,vMu);
  decl mMatchProb_fc=(mMatchProb[][vActive_cluster_fc]*mOutput_share'); /* Dimension: Nb Counties x nb FC */
  decl iHH_dist=sumc(sumr(mCounty_hh[][year].*mMatchProb[][vActive_cluster_fc].*mDist_county_cluster[][vActive_cluster_fc]))/sumc(mCounty_hh[][year]);
  decl iHH_inc_dist=sumc(sumr(mCounty_high_income[][year].*mMatchProb[][vActive_cluster_fc].*mDist_county_cluster[][vActive_cluster_fc]))/sumc(mCounty_high_income[][year]);
  decl iHH_young_dist=sumc(sumr(mCounty_pop_young[][year].*mMatchProb[][vActive_cluster_fc].*mDist_county_cluster[][vActive_cluster_fc]))/sumc(mCounty_pop_young[][year]);
  
  /* Sortation network */
  decl aNetwork_sortation,aSortation_zone,aDist_fc_sc;    
  aNetwork_sortation=aNetwork_combined[iNetwork_sortation];
  aSortation_zone=aNetwork_combined[iSortation_zone];
  aDist_fc_sc=aNetwork_combined[iDist_fc_sc]; 

  /* Indicator variable equal to one with a county and FCs are connected: Nb Counties x Nb of Active FC */
  decl mSortationNetwork;
  if(id_sc==<>) {
    mSortationNetwork=zeros(M,1);
  }
  else mSortationNetwork=setbounds((aSortation_zone[year])[][id_sc]*aNetwork_sortation[year]',0,1);
  decl iHH_vi=sumc(sumr(mCounty_hh[][year].*mMatchProb_fc.*mSortationNetwork))/scale;
  decl mDist_county_facilities=mDist_county_cluster*mDummy_cluster';
  decl iHH_vi_dist;
  if(iHH_vi>0) iHH_vi_dist=sumc(sumr(mCounty_hh[][year].*mMatchProb_fc.*mSortationNetwork.*mDist_county_facilities[][id_fc])/scale)/iHH_vi;
  else iHH_vi_dist=0;
  /******************************/
  aHH_dist[0]=iHH_dist~iHH_vi_dist~iHH_inc_dist~iHH_young_dist;
  aHH_vi[0]=iHH_vi./(sumc(mCounty_hh[][year])/scale);
  /******************************/
  return 1;
}
