spending_func(aAmazonSpending,aAmazonNetRevenue,aAmazonQ,const mAmazonTax,const vNetwork_density)
{
  decl mAmazonSpending=new matrix[M][T];
  /* These are the spending shares for each mode */
  decl mRatio_mode1=exp(aSpendingInt[0]+iDensityParam*vNetwork_density+mCES_param.*(log(1+vAmazonShare.*mAmazonTax)-log(1+mCounty_tax)));
  decl mRatio_mode2=exp(aSpendingInt[1]);
  decl mRatio_mode3=exp(aSpendingInt[2]-mCES_param.*log(1+mCounty_tax));
  decl mSumRatio=mRatio_mode1+mRatio_mode2+mRatio_mode3;
  /* Us identity from Peter's note to compute an expression from the spending share on model zero given data on total retail spending */
  decl mSpending_mode0=mRetailSpending.*((1+mSumRatio).^(-1));
  /* This is also comping from Peter's notes */
  /* Tax incl. spending is total Amazon revenue in each county/year */
  decl mAmazonSpending_tax_incl=mRatio_mode1.*mSpending_mode0;
  /* Tax excl spending account for the market-place share */
  decl mAmazonSpending_tax_excl=vAmazonShare.*(mAmazonSpending_tax_incl./(1+vAmazonShare.*mAmazonTax));
  decl mMPSpending_tax_excl=(1-vAmazonShare).*(mAmazonSpending_tax_incl./(1+vAmazonShare.*mAmazonTax));
  decl mSumAmazonSpending_tax_excl=mAmazonSpending_tax_excl+mMPSpending_tax_excl;
  /* Net reveue is calculated on the after-tax revenue */
  decl mAmazonNetRevenue=iMu_amazon*mAmazonSpending_tax_excl+iMu_mp*mMPSpending_tax_excl;  
  aAmazonSpending[0]=mSumAmazonSpending_tax_excl;
  aAmazonNetRevenue[0]=mAmazonNetRevenue;
  /* Orders are calculated using the (pre-determined) amazon price which vary from year to year */
  aAmazonQ[0]=mSumAmazonSpending_tax_excl./mAmazonPrice_tax_excl;  
  return 1;
}
amazon_tax_func(aAmazon_tax,const mFC_county_presence)
{
 
  decl vEntryYear=minr((mFC_county_presence.*vYear)+(1-mFC_county_presence)*(2040)); /* This is produces a row vector with the entry year in each county (all facility types included) */
  decl vTaxYear=constant(2017,M,1);
  decl i,id;
  decl vUnique_state_code=unique(vState_code);
  println("dimension tax delay vector: ",rows(vTax_delay)~columns(vTax_delay));
  println("dimension of entry date vector: ",rows(vEntryYear)~columns(vEntryYear));	
  for(i=0;i<T;i++)
    {
      id=vecindex(vEntryYear,vYear[i]);
      vTaxYear[id]=vEntryYear[id]+vTax_delay[i]; /* This update the effective taxable date for the county based on the first entry date in the county */
    }
  decl vTaxYear_state=new matrix[rows(vTaxYear)][1];
  for(i=0;i<columns(vUnique_state_code);i++)
    {
      id=vecindex(vState_code,vUnique_state_code[i]);
      vTaxYear_state[id]=constant(minc(vTaxYear[id]),id);  /* This calculates the earliest taxable year in the state based on physical presence and delay */
    }
  /* The lines below adjust for the deterministic delays outside of the model */
  vTaxYear_state=setbounds(vTaxYear_state,0,2017);
  vTaxYear_state[vecindex(vState_code,33)]=2008; /* NY State */
  vTaxYear_state[vecindex(vState_code,48)]=2005; /* Washington */
  vTaxYear_state[vecindex(vState_code,35)]=2005; /* North Dakota */
  decl mAmazon_tax=(vTaxYear_state.<=vYear).*mCounty_tax;
  aAmazon_tax[0]=mAmazon_tax;
}