spending_func(aAmazonSpending,aAmazonNetRevenue,aAmazonQ,const vAmazonTax,const vNetwork_density)
{
  decl mAmazonSpending=new matrix[M][1];
  /* These are the spending shares for each mode */
  decl mRatio_mode1=exp((aSpendingInt[0])[][year]+iDensityParam*vNetwork_density[year]+mCES_param[][year].*(log(1+vAmazonShare[year].*vAmazonTax)-log(1+mCounty_tax[][year])));
  decl mRatio_mode2=exp((aSpendingInt[1])[][year]);
  decl mRatio_mode3=exp((aSpendingInt[2])[][year]-mCES_param[][year].*log(1+mCounty_tax[][year]));
  decl mSumRatio=mRatio_mode1+mRatio_mode2+mRatio_mode3;
  /* Use identity from Peter's note to compute an expression from the spending share on model zero given data on total retail spending */
  decl mSpending_mode0=mRetailSpending[][year].*((1+mSumRatio).^(-1));
  /* Tax incl. spending is total Amazon revenue in each county/year */
  decl mAmazonSpending_tax_incl=mRatio_mode1.*mSpending_mode0;
  /* Tax excl spending account for the market-place share */
  decl mAmazonSpending_tax_excl=vAmazonShare[year].*(mAmazonSpending_tax_incl./(1+vAmazonShare[year].*vAmazonTax));
  decl mMPSpending_tax_excl=(1-vAmazonShare[year]).*(mAmazonSpending_tax_incl./(1+vAmazonShare[year].*vAmazonTax));
  decl mSumAmazonSpending_tax_excl=mAmazonSpending_tax_excl+mMPSpending_tax_excl;
  /* Net reveue is calculated on the after-tax revenue */
  decl mAmazonNetRevenue=iMu_amazon*mAmazonSpending_tax_excl+iMu_mp*mMPSpending_tax_excl;    
  aAmazonSpending[0]=mSumAmazonSpending_tax_excl;
  aAmazonNetRevenue[0]=mAmazonNetRevenue;
  /* Orders are calculated using the (pre-determined) amazon price which vary from year to year */
  aAmazonQ[0]=mSumAmazonSpending_tax_excl./mAmazonPrice_tax_excl[][year];
  return 1;
}
amazon_tax_func(aAmazon_tax,const vCounty_presence)
{
  decl vUnique_state_code=unique(vState_code);
  decl vDummy_taxable=new matrix[M][1];
  decl i;
  decl id;
  decl vAmazon_tax;
  if(iTaxDelay>0) {
    parallel for(i=0;i<columns(vUnique_state_code);i++)
      {
	id=vecindex(vState_code,vUnique_state_code[i]);
	vDummy_taxable[id]=constant(maxc(vCounty_presence[id]),id);
      }
    vAmazon_tax=mCounty_tax[][year].*(vDummy_taxable+(1-vDummy_taxable)*(1-iTaxDelay));
  }
  else vAmazon_tax=mCounty_tax[][year];
  aAmazon_tax[0]=vAmazon_tax;
}