#delimit;
global computer "Local";
if "$computer" == "Local" {;
	local intermediate_dir "~/Dropbox/Amazon_FC/Data/Processed/Intermediate";
	local swap_dir "~/Dropbox/Amazon_FC/Data/Processed/Swap_list";
	local main_dir "~/Dropbox/Amazon_FC/Data/Processed/Main";
	local county_dir "~/Dropbox/Amazon_FC/Data/County_Characteristics";
	local FC_dir "~/Dropbox/Amazon_FC/Data/FCs";
	local prediction_dir "~/Dropbox/Amazon_FC/Data/Processed/Main";
	local Amazon_report "~/Dropbox/Amazon_FC/Data/Amazon";
	local predicted_revenue "~/Dropbox/Amazon_FC/Data/Processed/Swap_list/amazon_revenue";
	local tables_dir "~/Dropbox/Amazon_FC/Tables_and_Figures";
	local oxfiles_dir "~/Dropbox/Amazon_FC/Analysis/Oxfiles";

	};
if "$computer" == "Linstat" {;
	local intermediate_dir "/project/houde/Amazon_FC/Data/Processed/Intermediate";
	local swap_dir "/project/houde/Amazon_FC/Data/Processed/Swap_list";
	local main_dir "/project/houde/Amazon_FC/Data/Processed/Main";
	local county_dir "/project/houde/Amazon_FC/Data/County_Characteristics";
	local FC_dir "/project/houde/Amazon_FC/Data/FCs";
	local tables_dir "/project/houde/Amazon_FC/Tables_and_Figures";
	};	
cd "`oxfiles_dir'";


use Results/AC_demand_grid_NLS, clear;
gen log_output=log(Output);


bysort demand_grid: egen min_AC=min(AC);
twoway  (line min_AC log_output if year==2018,lwidth(thick) lcolor(cranberry))
	(line AC log_output if year==1999 & AC<4, lcolor(gs12) lpattern(shortdash))
	(line AC log_output if year==2003 & AC<4, lcolor(gs10) lpattern(shortdash_dot)) 		
	(line AC log_output if year==2006 & AC<4, lcolor(gs8) lpattern(dash)) 
	(line AC log_output if year==2012 & AC<4, lcolor(gs6) lpattern(dash_dot)) 
	(line AC log_output if year==2015 & AC<4, lcolor(gs4) lpattern(longdash)) 
	(line AC log_output if year==2018 & AC<4, lcolor(gs2) lpattern(longdash_dot)), 
	ytitle(Average Cost) xtitle(Output (log))
	legend(label(1 "LR-AC") label(2 "1999") label(3 "2003") label(4 "2006") label(5 "2012") label(6 "2015")  label(7 "2018") order(1 2 3 4 5 6 7) col(4));
gr export "`tables_dir'/Figure_LR_avgcost.pdf", replace;

keep if abs(AC-min_AC)<10^(-4);
scatter year log_output, ytitle("Network vintage") xtitle(Output (log));
gr export "`tables_dir'/Figure_LR_technology_vintage.pdf", replace;
 
