#include<oxstd.h>
#import <maximize>
#import <solvenle>
#include <oxdraw.h>
#include <oxfloat.h>
#include <oxprob.h>
#import <maxsqp>

#import<network_logistic_func>
#import<annual_spending_func>
#import<enumerate>
enum{cross_county_code,cross_cluster_id,cross_dist}; /* Cross-section: County-cluster list */

enum{cluster_id0,cluster_lat0,cluster_long0,cluster_state_code0,cluster_county_code0,cluster_density0,cluster_id1,
     cluster_lat1,cluster_long1,cluster_state_code1,cluster_county_code1,cluster_density1,
     cluster_dist,congestion,cluster_congest_dist}; /* Cluster distance */

enum{type_fresh=1,type_nonsortable,type_prime,type_sortable,type_callcenter,type_idx,type_returns,type_delivery,type_sortation};

enum{fc_cluster_id,fc_id,fc_county_code,fc_sq_ft,fc_oyear,fc_cyear,fc_typeid,fc_cluster_lat,fc_cluster_lng,fc_swapid,fc_year,fc_pop_density,fc_county_rent_dis_imputed,fc_imputed_wage,fc_state_code,fc_state_abbrev,fc_dummy_active};/* Facility panel */


enum{demo_state_code,demo_year,demo_pop_density,demo_nb_hh,demo_median_income,demo_house_value,
     demo_county_code,demo_rent,demo_wage,demo_lon,demo_lat,demo_tax,demo_amazon_tax,demo_msize,
     demo_hhincome_100000more,demo_mean_age,demo_pop_young,demo_share_young}; /* County-Demographic file */

enum{demand_year,demand_county,demand_mode,demand_nb_hh,demand_avg_spending_annual_county,
     demand_alpha,demand_tax_rate,demand_tax_status,demand_density1,demand_perc_100,demand_tax_coeff,
     demand_tax_coeff100,demand_density_coeff,demand_am_share,demand_margin0,demand_prods_per,
     demand_pre_laprice1,demand_pre_lmprice1,demand_pre_liquart1,demand_pre_lstd1,demand_a_margin,demand_mp_margin}; /* Demand variables */

enum{cluster_county_code,cluster_lat,cluster_long,cluster_id,cluster_state_code,cluster_year,
     cluster_pop_density,cluster_county_rent_dis_imputed,cluster_imputed_wage}; /* Cluster_characteristics */

/* Common variables */
enum{imu_0,imu_k,imu_t,ialpha,iAfc,iAsc,ibeta,igamma,nbParam};
enum{iShip_int,iShip_dist,iShip_vi,iFC_dens};
enum{iNetwork_sortation,iSortation_zone,iDist_fc_sc};
decl aParamName={"$\\mu_0$","$\\mu_k$","$\\mu_t$","$\\alpha$","$A_{fc}$","$A_{sc}$","$\\beta$","$\\gamma$"};
decl vYear,vVariety;
decl N,M,T,nbFC;
decl mDist_county_cluster;
decl mDistance_cluster;
decl vParam_logistic;
decl vCluster_id,vCounty_id,vUnique_fcid;
decl mDummy_cluster_county,vTax_delay,mTotalSpending,mCES_param,iMu_param,iMu_amazon,iMu_mp,aSpendingInt,scale,vState_code;
decl vAmazonShare,mAmazonPrice_tax_excl,mRetailSpending;
decl vNearestCounty_id,mCounty_wage,mCounty_rent,mCounty_density,mCounty_tax,mCounty_hh,mCluster_wage,mCluster_density,mCluster_rent,vParam_cost;
decl mCounty_high_income,mCounty_age,mCounty_share_young,mCounty_pop_young,vNetwork_density_obs;
decl iSortThreshold=150;
decl iFCThreshold=25;
decl iMinDist=25;
decl iConvenience;
decl iprint=1;
decl iFC_cap=1;
decl iSC_cap=0.3;
decl iDummy_SC=0;
decl iSingleFC=0;
decl iNearestFC=1;
decl year;
decl vSimPI_cumu,mSimLocation_cumu;

/************************************************************/
/* Specifications */
decl iTaxDelay,iVariety,iDensityParam,iLargeCES,iEstimator,iClusterThreshold;
enum{iLR_fc,iLR_sc,iMUT_PROB,iMUT_SHIFT,iMAXIT,iSequential_update,iSim,inbRuns,iGreedy,nbTuning_param};
decl aTuning_param={"LR_fc","LR_sc","MUT_PROB","MUT_SHIFT","MAXIT","iSequential_update","Sim","nbRuns","Greedy"};
/*************************************************************/

main()
{
  format(1000);
  format(1000);
  decl i,j,k;

  /**********************************************************/
  /* Parameters: Specification */
  iTaxDelay=2;
  iVariety=1;
  iConvenience=0;
  iEstimator="NLS";
  iClusterThreshold=20;
  decl demand_spec=2;
  decl OPTid=<1;2;3>;
  decl iCluster=0;
  vParam_logistic=loadmat(sprint("Results/matching_function_param_",iEstimator,"_variety",iVariety,"_spec",demand_spec,".mat"));
  decl mParam_cost_CI=loadmat(sprint("Results/CI_cost_nbparam_",rows(OPTid),"_taxdelay",iTaxDelay,"_",iEstimator,"_cluster",iCluster,".csv"));
  println("Param CI: ",mParam_cost_CI);
  vParam_cost=new matrix[4][1];
  vParam_cost=mParam_cost_CI[][0];
  println("param_cost: ",vParam_cost);
  println("shipping cost param (dist): ",vParam_cost[iShip_dist]);
  println("shipping cost param (vi): ",vParam_cost[iShip_vi]);
  println("shipping cost param (density): ",vParam_cost[iFC_dens]);

  /* Tax Status */
  iTaxDelay=1;


  println("%r",aParamName,vParam_logistic);
  println("Tax Delay indicator : ",iTaxDelay);
  println("Variety: ",iVariety);
  println("Convenience: ",iConvenience);
  println("iEstimator: ",iEstimator);
  println("iSortThreshold: ",iSortThreshold);
  println("iFCThreshold: ",iFCThreshold);
  println("iClusterThreshold: ",iClusterThreshold);
  
  /**********************************************************/
  /* Load Data-sets: Fixed covariates */
  decl output_dir="../output/";
  decl main_dir="../../Data/Processed/Main/";
  decl swap_dir="../../Data/Processed/Swap_list/";
  scale=1000000; /* Capacity and revenue scale variable */
  decl aVarName_cross,aVarName_fc,aVarName_distance,aVarName_county_distance;
  decl mCrossData=loadmat(sprint(main_dir,"Distance_matrix_county_cluster.dta"),&aVarName_cross);
  decl mDistanceData=loadmat(sprint(main_dir,"Cluster_distance_threshold20.dta"),&aVarName_distance);
  decl mFacilityData=loadmat(sprint(swap_dir,"Facility_panel_threshold20.dta"),&aVarName_fc);
  mFacilityData[][fc_sq_ft]./=scale;
  
  decl aVarName_demo;
  decl mDemoData=loadmat(sprint(main_dir,"County_demo_variables.dta"),&aVarName_demo);
  mDemoData=sortbyc(mDemoData,<demo_county_code,demo_year>);  

  println("%r",aVarName_demo,(meanc(mDemoData)|sqrt(varc(mDemoData)))');
  println("%r",aVarName_fc,meanc(mFacilityData)'~sqrt(varc(mFacilityData))');

  decl aVarName_variety;
  decl mVariety_index=loadmat(sprint(main_dir,"Variety_index_spec",demand_spec,".dta"),&aVarName_variety);
  println("%c",aVarName_variety,mVariety_index);
  vVariety=mVariety_index[][1]';

  decl aSpendingVar_names;
  decl mSpendingComponents=loadmat(sprint(main_dir,"ces_data",demand_spec,".csv"),&aSpendingVar_names);
  mSpendingComponents=sortbyc(mSpendingComponents,<demand_mode,demand_county,demand_year>);
    
  decl mSpendingComponents_mode1=selectifr(mSpendingComponents,mSpendingComponents[][demand_mode].==1);
  decl mSpendingComponents_mode2=selectifr(mSpendingComponents,mSpendingComponents[][demand_mode].==2);
  decl mSpendingComponents_mode3=selectifr(mSpendingComponents,mSpendingComponents[][demand_mode].==3);
  
  /* Sort cross-data by county and cluster ID */
  mCrossData=sortbyc(mCrossData,<cross_county_code,cross_cluster_id>);
  mDistanceData=sortbyc(mDistanceData,<cluster_id0,cluster_id1>);
  mFacilityData=sortbyc(mFacilityData,<fc_id,fc_year>);
  println("unique type: ",unique(mFacilityData[][fc_typeid]));
  println(selectifr(mDistanceData,(mDistanceData[][cluster_id0].<=5).*(mDistanceData[][cluster_id1].<=5)));
	  
  /* Vector of IDs */
  vCluster_id=unique(mCrossData[][cross_cluster_id]);
  vCounty_id=unique(mCrossData[][cross_county_code]);
  vYear=unique(mDemoData[][demo_year]);
  vUnique_fcid=unique(mFacilityData[][fc_id]);
  
  N=columns(vCluster_id);
  M=columns(vCounty_id);
  T=columns(vYear);
  nbFC=columns(vUnique_fcid);
  println("N : ",N);
  println("M : ",M);
  println("nbFC : ",nbFC);
  println("T : ",T);
  
  /* Reshape wide distance matrix */
  mDistance_cluster=reshape(mDistanceData[][cluster_dist],N,N);
  mDist_county_cluster=reshape(mCrossData[][cross_dist],M,N)+iMinDist;
  println("mDistance_cluster: ",mDistance_cluster[:10][:10]);
  println("unique cluster id in distance data-set: ",columns(unique(mDistanceData[][cluster_id0]))~columns(unique(mDistanceData[][cluster_id1])));
  println("unique diagonal elements: ", unique(diagonal(mDistance_cluster)));
  println("mDistance_cluster: ",mDistance_cluster[:10][:10]);

  
  /* Reshape input price and tax variables */
  decl mCounty_code=reshape(mDemoData[][demo_county_code],M,T);
  mCounty_wage=reshape(mDemoData[][demo_wage],M,T);
  mCounty_rent=reshape(mDemoData[][demo_rent],M,T);
  mCounty_density=reshape(mDemoData[][demo_pop_density],M,T);
  mCounty_hh=reshape(mDemoData[][demo_nb_hh],M,T);
  mCounty_tax=reshape(mDemoData[][demo_tax],M,T);
  mCounty_high_income=reshape(mDemoData[][demo_hhincome_100000more],M,T).*mCounty_hh;
  mCounty_age=reshape(mDemoData[][demo_mean_age],M,T);
  mCounty_share_young=reshape(mDemoData[][demo_share_young],M,T);
  mCounty_pop_young=reshape(mDemoData[][demo_pop_young],M,T);
  decl iAvgDensity=sumc(mCounty_density[][T-1].*mCounty_hh[][T-1])./sumc(mCounty_hh[][T-1]);
  vState_code=reshape(mDemoData[][demo_state_code],M,T)[][0];
  println("%c",{"year","variety ratio"},(vYear|vVariety)');

  /* Cluster locations */
  decl mCluster_gps=new matrix[N][2];
  decl id;
  for(i=0;i<N;i++)
    {
      id=vecindex(mFacilityData[][fc_cluster_id],vCluster_id[i]);
      mCluster_gps[i][]=meanc(mFacilityData[id][fc_cluster_lat])~meanc(mFacilityData[id][fc_cluster_lng]);
      if(id==<>) println("Problem!!!!");
    }
  
  /* Reshape wide demand parameters */
  iMu_param=unique(mSpendingComponents_mode1[][demand_margin0]);
  iMu_amazon=unique(mSpendingComponents_mode1[][demand_a_margin]);
  iMu_mp=unique(mSpendingComponents_mode1[][demand_mp_margin]);
  println("Profit margin: ",iMu_param);
  decl mSpendingAlpha_mode1=reshape(mSpendingComponents_mode1[][demand_alpha],M,T);
  decl mSpendingAlpha_mode2=reshape(mSpendingComponents_mode2[][demand_alpha],M,T);
  decl mSpendingAlpha_mode3=reshape(mSpendingComponents_mode3[][demand_alpha],M,T);
  aSpendingInt=new array[3];
  aSpendingInt[0]=mSpendingAlpha_mode1;
  aSpendingInt[1]=mSpendingAlpha_mode2;
  aSpendingInt[2]=mSpendingAlpha_mode3;
  
  /* Construct matrices of amazon characteristics */
  vAmazonShare=reshape(mSpendingComponents_mode1[][demand_am_share],M,T)[0][];
  //vAmazonShare=ones(1,T);
  mRetailSpending=reshape(mSpendingComponents_mode1[][demand_avg_spending_annual_county],M,T);
  mAmazonPrice_tax_excl=reshape(mSpendingComponents_mode1[][demand_pre_laprice1],M,T);
  decl vAvgPrice_tax_excl=sumc(mAmazonPrice_tax_excl.*mCounty_hh)./sumc(mCounty_hh);
  println("Population weighted average price: ");
  println("%c",{"year","avg. price","variety"},vYear'~vAvgPrice_tax_excl'~vVariety');  
  decl mCounty_per_100=reshape(mSpendingComponents_mode1[][demand_perc_100],M,T);
  decl iCES_coef_int=unique(mSpendingComponents_mode1[][demand_tax_coeff]);
  decl iCES_coef_slope=unique(mSpendingComponents_mode1[][demand_tax_coeff100]);
  vNetwork_density_obs=reshape(mSpendingComponents_mode1[][demand_density1],M,T)[0][];
  iDensityParam=unique(mSpendingComponents_mode1[][demand_density_coeff]);
  println("iCES_coef_int: ",iCES_coef_int);
  println("iCES_coef_slope: ",iCES_coef_slope);
  decl max_inc_share=(1.1-iCES_coef_int)/iCES_coef_slope;
  println("max_inc_share: ",max_inc_share);
  mCES_param=1-iCES_coef_int-iCES_coef_slope.*setbounds(mCounty_per_100,0,max_inc_share);  
  decl mAmazon_tax_obs=reshape(mDemoData[][demo_amazon_tax],M,T);
  println("Density parameter: ",iDensityParam);
  println("network density:: ",(vYear|vNetwork_density_obs)');

  /****************************************************************************************************/
  /* Invariant characteristics */
  decl vFC_capacity=reshape(mFacilityData[][fc_sq_ft],nbFC,T)[][0];
  decl vFC_type=reshape(mFacilityData[][fc_typeid],nbFC,T)[][0];
  decl vFC_cluster=reshape(mFacilityData[][fc_cluster_id],nbFC,T)[][0];
  decl vFC_state_code=reshape(mFacilityData[][fc_state_code],nbFC,T)[][0];
  decl vFC_county_code=reshape(mFacilityData[][fc_county_code],nbFC,T)[][0];
  decl vFC_oyear=reshape(mFacilityData[][fc_oyear],nbFC,T)[][0];
  decl vDummy_sc=vFC_type.==type_sortation;
  decl vDummy_fc=(vFC_type.==type_sortable)+(vFC_type.==type_nonsortable);
  decl id_fc=vecindex(vDummy_fc,1);
  decl id_sc=vecindex(vDummy_sc,1);
  decl aID=new array[2];
  aID[0]=id_fc;
  aID[1]=id_sc;
  /* Replace capacity with common capacity measure */
  vFC_capacity[id_fc]=iFC_cap;
  vFC_capacity[id_sc]=iSC_cap;
  println("nb of FC:" ,rows(id_fc));

  /****************************************************************************************************/
  /* Reshape wide facility data: Activity and cost */
  decl vFC_id=reshape(mFacilityData[][fc_id],nbFC,T)[][0];
  decl mFC_activity=reshape(mFacilityData[][fc_dummy_active],nbFC,T);
  decl mFC_wage=reshape(mFacilityData[][fc_imputed_wage],nbFC,T);
  decl mFC_rent=reshape(mFacilityData[][fc_county_rent_dis_imputed],nbFC,T);
  decl mFC_density=reshape(mFacilityData[][fc_pop_density],nbFC,T);

  /***************************************************************************/
  /* Calculate input prices for each locations */
  mCluster_wage=new matrix[N][T];
  mCluster_rent=new matrix[N][T];
  mCluster_density=new matrix[N][T];
  decl mDummy_cluster=(vFC_cluster.==vCluster_id); /* nbFC x Nb cluster */
  mCluster_wage=(mDummy_cluster'mFC_wage)./setbounds(sumc(mDummy_cluster),1,M_INF_POS)';
  mCluster_rent=(mDummy_cluster'mFC_rent)./setbounds(sumc(mDummy_cluster),1,M_INF_POS)';
  mCluster_density=(mDummy_cluster'mFC_density)./setbounds(sumc(mDummy_cluster),1,M_INF_POS)';
  decl vCluster_county_code=new matrix[N][1];
  decl vCluster_state_code=new matrix[N][1];
  mDummy_cluster_county=zeros(N,M);
  for(i=0;i<N;i++)
    {
      id=vecindex(mDummy_cluster[][i],1);
      vCluster_county_code[i]=unique(vFC_county_code[id]);
      vCluster_state_code[i]=unique(vFC_state_code[id]);
    }
  mDummy_cluster_county=vCluster_county_code.==vCounty_id;
  decl CA_id=vecindex(vCluster_state_code,6);
  

  /***************************************************************************/
  /* Indicator function classifying each regular fulfillment center in each cluster: (nb facility) x N) */
  println("California FCs: ",sortbyc(selectifr(vFC_cluster[id_fc]~vFC_oyear[id_fc]~vFC_county_code[id_fc]~vFC_capacity[id_fc],vFC_state_code[id_fc].==6),<0,1>));
  println("Arizona FCs: ",sortbyc(selectifr(vFC_cluster[id_fc]~vFC_oyear[id_fc]~vFC_county_code[id_fc]~vFC_capacity[id_fc],vFC_state_code[id_fc].==4),<0,1>));
  println("Nevada FCs: ",sortbyc(selectifr(vFC_cluster[id_fc]~vFC_oyear[id_fc]~vFC_county_code[id_fc]~vFC_capacity[id_fc],vFC_state_code[id_fc].==32),<0,1>));
  decl iAZ_cluster=vecindex(vCluster_id,49);
  decl iSanBernardino_cluster=vecindex(vCluster_id,40);
  decl nbFC_SanBernardino=rows(vecindex(vFC_cluster[id_fc],40));
  decl Capacity_SanBernardino=sumc(selectifr(vFC_capacity[id_fc],vFC_cluster[id_fc].==40));
  println("nb of facilities and capacity in SanBernardino County: ",nbFC_SanBernardino~Capacity_SanBernardino);

  /************************************************************************/
  /* Evalute average cost and distribution for alternative networks */
  decl vCounty_presence,mOutput,mDist,mLabor,mMatchProb,id_fc_active,mRankFC,mMatchProb_active,mDist_county_cluster_active,mRankedProb,vShippingDistance;
  decl vAmazonSpending,vCounty_demand,vAmazonNetRevenue,vAmazon_tax,vWeight,vWeight_pop,vSC,vDemand_density;
  decl vOutput_obs,vOutput_cf;
  iprint=0;
  decl time0=timer();
  decl iMultiplier;
  decl iAvgProfit,mAvgCost_obs,mAvgCost_cf,vLogistic,vTax,iQ,mPI,mPI_obs;
  decl mCluster_location,mCluster_capacity;
  decl mLogisticResults=<>;
  decl mACResults=<>;
  decl vProfit_obs,vProfit_cf,mResults,mResults_level;
  year=8;
  decl it=0; 
  println("Network year: ",vYear[year]);
  decl vDiversion,mDiversion=<>;
  decl mu_0=vParam_logistic[imu_0];
  decl file;
  decl row_label;
  for(year=5;year<=12;year++)
    {
      vParam_logistic[imu_0]=mu_0;
      mDiversion=<>;
      println("//////////////////////////////////////////////////////////");
      println("year: ",vYear[year]);
      do{
	println("Logistic parameter: ",vParam_logistic[imu_0]);
	/*******************************************************************/
	/* Construct cluster location matrix */
	mCluster_location=new matrix[N][2];
	mCluster_location[][0]=sumc(mFC_activity[id_fc][year].*mDummy_cluster[id_fc][])';
	mCluster_location[][1]=setbounds(sumc(mFC_activity[id_sc][year].*mDummy_cluster[id_sc][])',0,1);
	mCluster_capacity=(sumc(mFC_activity[id_fc][year].*vFC_capacity[id_fc].*mDummy_cluster[id_fc][])')~(sumc(mFC_activity[id_sc][year].*vFC_capacity[id_sc].*mDummy_cluster[id_sc][])');
	id_fc_active=vecindex(mCluster_location[][0].>0,1);
  
	/* Compute taxes and distribution of orders */
	/* Revenue: Tax and Orders */
	vCounty_presence=(sumr(mCluster_location)'mDummy_cluster_county)';
	vCounty_presence=vCounty_presence.>0;
	amazon_tax_func(&vAmazon_tax,vCounty_presence);
	spending_func(&vAmazonSpending,&vAmazonNetRevenue,&vCounty_demand,vAmazon_tax,vNetwork_density_obs);
	vAmazon_tax=100*vAmazonShare[year].*vAmazon_tax;
	vCounty_demand.*=mCounty_hh[][year]/scale;
	vAmazonNetRevenue.*=mCounty_hh[][year]/scale;
  
	/* Output: Distance, output and labor demand functions per facility/location */
	logistic_func(&mOutput,&mDist,&mLabor,&mMatchProb,mCluster_location~mCluster_capacity,vCounty_demand);

	/* Profit components */
	facility_profit(mCluster_location~mCluster_capacity,&vCounty_demand,&mPI_obs);
	mAvgCost_obs=new matrix[N][5];
	mAvgCost_obs[id_fc_active][]=mPI_obs[id_fc_active][2:]./mPI_obs[id_fc_active][0];
	vOutput_obs=mPI_obs[][0];
	vProfit_obs=mPI_obs[][1]-(mPI_obs[][columns(mPI_obs)-1]);
    	    
	/*******************************************************************/
	/* Add california cluster */
	println("nb of facilities in San Bernardino: ",mCluster_location[iSanBernardino_cluster][]);
	mCluster_location[iSanBernardino_cluster][0]=3;
	mCluster_location[iSanBernardino_cluster][1]=0;
	mCluster_capacity[iSanBernardino_cluster][0]=mCluster_location[iSanBernardino_cluster][0]*iFC_cap;
	
	vCounty_presence=(sumr(mCluster_location)'mDummy_cluster_county)';
	vCounty_presence=vCounty_presence.>0;
	amazon_tax_func(&vAmazon_tax,vCounty_presence);
	spending_func(&vAmazonSpending,&vAmazonNetRevenue,&vCounty_demand,vAmazon_tax,vNetwork_density_obs);
	vAmazon_tax=100*vAmazonShare[year].*vAmazon_tax;
	vCounty_demand.*=mCounty_hh[][year]/scale;
	vAmazonNetRevenue.*=mCounty_hh[][year]/scale;

	/* Output: Distance, output and labor demand functions per facility/location */
	logistic_func(&mOutput,&mDist,&mLabor,&mMatchProb,mCluster_location~mCluster_capacity,vCounty_demand);

	/* Profit components */
	facility_profit(mCluster_location~mCluster_capacity,&vCounty_demand,&mPI);
	mAvgCost_cf=new matrix[N][5];
	mAvgCost_cf[id_fc_active][]=mPI[id_fc_active][2:]./mPI[id_fc_active][0];
	vOutput_cf=mPI[][0];
	vProfit_cf=mPI[][1]-(mPI[][columns(mPI)-1]);
	vDiversion=new matrix[N][1];
	vDiversion[id_fc_active]=(vOutput_cf[id_fc_active]-vOutput_obs[id_fc_active])./vOutput_cf[iSanBernardino_cluster];
	println("sum diversion: ",sumc(vDiversion[id_fc_active]));

	println("Change in AC (%): ",vDiversion[id_fc_active]~((mAvgCost_cf[id_fc_active][]-mAvgCost_obs[id_fc_active][])./mAvgCost_obs[id_fc_active][]));
	mResults=sortbyc(mDistance_cluster[id_fc_active][iSanBernardino_cluster]~vCluster_state_code[id_fc_active]
			 ~vDiversion[id_fc_active]~((vProfit_cf[id_fc_active]-vProfit_obs[id_fc_active])./vProfit_obs[id_fc_active])
			 ~((mAvgCost_cf[id_fc_active][<0>]-mAvgCost_obs[id_fc_active][<0>])./mAvgCost_obs[id_fc_active][<0>])
			 ~((sumr(mAvgCost_cf[id_fc_active][<1,2,3>])-sumr(mAvgCost_obs[id_fc_active][<1,2,3>]))./sumr(mAvgCost_obs[id_fc_active][<1,2,3>])),0);

	mResults|=((sumc(vOutput_cf)-sumc(vOutput_obs))./sumc(vOutput_obs))~0~0
	  ~((sumc(vProfit_cf)-sumc(vProfit_obs))./sumc(vProfit_obs))
	  ~(sumc(mPI[][2])./sumc(mPI[][0])-sumc(mPI_obs[][2])./sumc(mPI_obs[][0]))
	  ~(sumc(sumr(mPI[][<3,4,5>]))./sumc(mPI[][0])-sumc(sumr(mPI_obs[][<3,4,5>]))./sumc(mPI_obs[][0]));
	println("%c",{"Distance","State","Diversion","Profit","SC","Other AC"},mResults);   

	/* Results: Levels */
	mResults_level=sortbyc(mDistance_cluster[id_fc_active][iSanBernardino_cluster]~vCluster_state_code[id_fc_active]~vOutput_obs[id_fc_active]
			       ~(vProfit_obs[id_fc_active])
			       ~(mAvgCost_obs[id_fc_active][<0>])
			       ~sumr(mAvgCost_obs[id_fc_active][<1,2,3>]),0);

	println("Result s(change): ",mResults);
	println("Results (observed levels): ",mResults_level);
	
	/* Save profit/cost change results */
	if(vParam_logistic[imu_0]==mu_0) {
	  row_label=new array[rows(id_fc_active)];
	  for(i=0;i<rows(id_fc_active);i++)
	    {
	      row_label[i]=sprint(i);
	    }
	  row_label~={"Total"};
	  savemat(sprint("Results/California_cf_year",vYear[year],"_taxdelay",iTaxDelay,".dta"),constant(vYear[year],rows(mResults),1)~mResults,
		  {"Year","Diversion","Profit","SC","AC"});
	  file = fopen(sprint("Results/California_cf_year",vYear[year],"_taxdelay",iTaxDelay,".tex"), "w");
	  fprintln(file,"\\centering");
	  fprintln(file,"\\begin{tabular}{ccccc}");
	  fprintln(file,"\\hline");
	  fprintln(file,"Distance & State & Diversion &  Profit & Shipping  & Labor+FC \\\ ");
	  fprintln(file,"%cf",{"%9.2f","& %9.2f","& %9.2f","& %9.2f","& %9.2f","& %9.2f \\\ "},	   
		   "%c",{"(miles)","& \\% ","& \\% ","& \\%","& \\% \\\ "},mResults);
	  fprintln(file,"\\hline");
	  fprintln(file,"\\end{tabular}");
	  fclose(file);	  
	}
	
	vParam_logistic[imu_0]*=(1+0.5);
	mDiversion~=vDiversion;
	
      }while(vParam_logistic[imu_0]<6);
      savemat(sprint("Results/Diversion_distance_year",vYear[year],"_taxdelay",iTaxDelay,".dta"),vCluster_id[id_fc_active]'~mCluster_gps[id_fc_active][]
	      ~(ones(rows(id_fc_active),2).*meanc(mCluster_gps[iSanBernardino_cluster][]))
	      ~mDistance_cluster[id_fc_active][iSanBernardino_cluster]	  
	      ~mCluster_capacity[id_fc_active][0]~mDiversion[id_fc_active][],{"cluster_id","cluster_lat","cluster_lng","ca_lat","ca_lng","distance","cluster_cap",
		  "diversion1","diversion2","diversion3","diversion4","diversion5"});
    }

}