#include<oxstd.h>
#import <maximize>
#import <solvenle>
#include <oxdraw.h>
#include <oxfloat.h>
#include <oxprob.h>
#import <maxsqp>

#import<logistic_func>
#import<spending_func>
#import<enumerate>

enum{cross_county_code,cross_cluster_id,cross_dist}; /* Cross-section: County-cluster list */

enum{cluster_id0,cluster_lat0,cluster_long0,cluster_state_code0,cluster_county_code0,cluster_density0,cluster_id1,
     cluster_lat1,cluster_long1,cluster_state_code1,cluster_county_code1,cluster_density1,
     cluster_dist,congestion,cluster_congest_dist}; /* Cluster distance */

enum{type_fresh=1,type_nonsortable,type_prime,type_sortable,type_callcenter,type_idx,type_returns,type_delivery,type_sortation};

enum{fc_cluster_id,fc_id,fc_county_code,fc_sq_ft,fc_oyear,fc_cyear,fc_typeid,fc_cluster_lat,fc_cluster_lng,fc_swapid,fc_year,fc_pop_density,
     fc_county_rent_dis_imputed,fc_imputed_wage,fc_state_code,fc_state_abbrev,fc_dummy_active}; /* Facility panel */


enum{demo_state_code,demo_year,demo_pop_density,demo_nb_hh,demo_median_income,demo_house_value,
     demo_county_code,demo_rent,demo_wage,demo_lon,demo_lat,demo_tax,demo_amazon_tax,demo_msize,
     demo_hhincome_100000more,demo_mean_age,demo_pop_young,demo_share_young}; /* County-Demographic file */

enum{demand_year,demand_county,demand_mode,demand_nb_hh,demand_avg_spending_annual_county,
     demand_alpha,demand_tax_rate,demand_tax_status,demand_density1,demand_perc_100,demand_tax_coeff,
     demand_tax_coeff100,demand_density_coeff,demand_am_share,demand_margin0,demand_prods_per,
     demand_pre_laprice1,demand_pre_lmprice1,demand_pre_liquart1,demand_pre_lstd1,demand_a_margin,demand_mp_margin}; /* Demand variables */

enum{cluster_county_code,cluster_lat,cluster_long,cluster_id,cluster_state_code,cluster_year,
     cluster_pop_density,cluster_county_rent_dis_imputed,cluster_imputed_wage}; /* Cluster_characteristics */

enum{county_code2,lon2,lat2,area2,county_code1,lon1,lat1,area1,dist}; /* County2County Distance variables */

/* Common variables */
enum{imu_0,imu_k,imu_t,ialpha,iAfc,iAsc,ibeta,igamma,nbParam};
enum{iShip_int,iShip_dist,iShip_vi,iFC_dens};
enum{iNetwork_sortation,iSortation_zone,iDist_fc_sc};
decl aParamName={"$\\mu_0$","$\\mu_k$","$\\mu_t$","$\\alpha$","$A_{fc}$","$A_{sc}$","$\\beta$","$\\gamma$"};
decl vYear,vVariety;
decl N,M,T,nbFC;
decl mDist_county_cluster;
decl mDistance_cluster;
decl vParam_logistic;
decl mFC_activity,vFC_capacity,vFC_type;
decl vCluster_id,vCounty_id,vUnique_fcid;
decl vFC_oyear,vFC_id,aID,vDummy_fc,vDummy_sc;
decl mDummy_cluster_county,vTax_delay,mTotalSpending,mCES_param,iMu_param,iMu_amazon,iMu_mp,aSpendingInt,scale,vState_code;
decl vAmazonShare,mAmazonPrice_tax_excl,mRetailSpending;
decl vNearestCounty_id,mCounty_wage,mCounty_rent,mCounty_density,mCounty_tax,mCounty_hh,mCluster_wage,mCluster_density,mCluster_rent,vParam_cost;
decl mCounty_high_income,mCounty_age,mCounty_share_young,mCounty_pop_young,vNetwork_density_obs;
decl iSortThreshold=150;
decl iFCThreshold=25;
decl iMinDist=25;
decl iConvenience;
decl iprint=1;
decl iFC_cap=1;
decl iSC_cap=0.3;
decl iDummy_SC=0;
decl iSingleFC=0;
decl year;
decl vSimPI_cumu,mSimLocation_cumu;

/************************************************************/
/* Specifications */
decl iTaxDelay,iVariety,iDensityParam,iLargeCES,iEstimator,iClusterThreshold;
enum{iLR_fc,iLR_sc,iMUT_PROB,iMUT_SHIFT,iMAXIT,iSequential_update,iSim,inbRuns,iGreedy,nbTuning_param};
decl aTuning_param={"LR_fc","LR_sc","MUT_PROB","MUT_SHIFT","MAXIT","iSequential_update","Sim","nbRuns","Greedy"};
/*************************************************************/

main()
{
  format(1000);
  format(1000);
  decl i,j,k;
  /**********************************************************/
  /* Parameters: Specification */
  iTaxDelay=2;
  iVariety=1;
  iConvenience=0;
  iEstimator="NLS";
  iClusterThreshold=20;
  decl demand_spec=2;
  decl OPTid=<1;2;3>;
  decl iCluster=0;
  vParam_logistic=loadmat(sprint("Results/matching_function_param_",iEstimator,"_variety",iVariety,"_spec",demand_spec,".mat"));
  decl mParam_cost_CI=loadmat(sprint("Results/CI_cost_nbparam_",rows(OPTid),"_taxdelay",iTaxDelay,"_",iEstimator,"_cluster",iCluster,".csv"));
  println("Param CI: ",mParam_cost_CI);
  vParam_cost=new matrix[4][1];
  vParam_cost=mParam_cost_CI[][0];
  println("param_cost: ",vParam_cost);
  println("shipping cost param (dist): ",vParam_cost[iShip_dist]);
  println("shipping cost param (vi): ",vParam_cost[iShip_vi]);
  println("shipping cost param (density): ",vParam_cost[iFC_dens]);

  /* Tax Status */
  iTaxDelay=1;

  println("%r",aParamName,vParam_logistic);
  println("Tax Delay indicator : ",iTaxDelay);
  println("Variety: ",iVariety);
  println("Convenience: ",iConvenience);
  println("iEstimator: ",iEstimator);
  println("iSortThreshold: ",iSortThreshold);
  println("iFCThreshold: ",iFCThreshold);
  println("iClusterThreshold: ",iClusterThreshold);
  
  /**********************************************************/
  /* Load Data-sets: Fixed covariates */
  decl output_dir="../output/";
  decl data_dir="../../Data/Processed/Main/";
  decl swap_dir="../../Data/Processed/Swap_list/";
  scale=1000000; /* Capacity and revenue scale variable */
  decl aVarName_cross,aVarName_fc,aVarName_distance,aVarName_county_distance;
  decl mCrossData=loadmat(sprint(data_dir,"Distance_matrix_county_cluster.dta"),&aVarName_cross);
  decl mDistanceData=loadmat(sprint(data_dir,"Cluster_distance_threshold20.dta"),&aVarName_distance);
  
  decl mCountyDistData=loadmat(sprint(data_dir,"Distance_county2county.dta"),&aVarName_county_distance);
  println("dim distance county2county: ",rows(mCountyDistData)~columns(mCountyDistData));
  println("%r",aVarName_county_distance,meanc(mCountyDistData)');
  
  decl aVarName_demo;
  decl mDemoData=loadmat(sprint(data_dir,"County_demo_variables.dta"),&aVarName_demo);
  mDemoData=sortbyc(mDemoData,<demo_county_code,demo_year>);  

  println("%r",aVarName_demo,(meanc(mDemoData)|sqrt(varc(mDemoData)))');
  
  decl aVarName_variety;
  decl mVariety_index=loadmat(sprint(data_dir,"Variety_index_spec",demand_spec,".dta"),&aVarName_variety);
  println("%c",aVarName_variety,mVariety_index);
  vVariety=mVariety_index[][1]';

  decl mSpendingComponents=loadmat(sprint(data_dir,"ces_data",demand_spec,".csv"));
  mSpendingComponents=sortbyc(mSpendingComponents,<demand_mode,demand_county,demand_year>);
  println("unique modes: ",unique(mSpendingComponents[][demand_mode]));
  decl mSpendingComponents_mode1=selectifr(mSpendingComponents,mSpendingComponents[][demand_mode].==1);
  decl mSpendingComponents_mode2=selectifr(mSpendingComponents,mSpendingComponents[][demand_mode].==2);
  decl mSpendingComponents_mode3=selectifr(mSpendingComponents,mSpendingComponents[][demand_mode].==3);  
  
  /* Sort cross-data by county and cluster ID */
  mCrossData=sortbyc(mCrossData,<cross_county_code,cross_cluster_id>);
  mDistanceData=sortbyc(mDistanceData,<cluster_id0,cluster_id1>);
  mCountyDistData=sortbyc(mCountyDistData,<county_code1,county_code2>);
   
  /* Vector of IDs */
  vCluster_id=unique(mCrossData[][cross_cluster_id]);
  vCounty_id=unique(mCrossData[][cross_county_code]);
  vYear=unique(mDemoData[][demo_year]);
  
  N=columns(vCluster_id);
  M=columns(vCounty_id);
  T=columns(vYear);

  println("N : ",N);
  println("M : ",M);
  println("T : ",T);
  
  /* Reshape wide distance matrix */
  mDistance_cluster=reshape(mDistanceData[][cluster_dist],N,N);
  mDist_county_cluster=reshape(mCrossData[][cross_dist],M,N)+iMinDist;
  decl mDist_county_county=reshape(mCountyDistData[][dist],M,M);
  decl mDummy_county_nearby=mDist_county_county.==0;
  println("dist county2county: ",mDist_county_county[:10][:10]);
  println("mDistance_cluster: ",mDistance_cluster[:10][:10]);
  
  /* Reshape input price and tax variables */
  decl mCounty_code=reshape(mDemoData[][demo_county_code],M,T);
  mCounty_wage=reshape(mDemoData[][demo_wage],M,T);
  mCounty_rent=reshape(mDemoData[][demo_rent],M,T);
  mCounty_density=reshape(mDemoData[][demo_pop_density],M,T);
  mCounty_hh=reshape(mDemoData[][demo_nb_hh],M,T);
  mCounty_tax=reshape(mDemoData[][demo_tax],M,T);
  mCounty_high_income=reshape(mDemoData[][demo_hhincome_100000more],M,T).*mCounty_hh;
  mCounty_age=reshape(mDemoData[][demo_mean_age],M,T);
  mCounty_share_young=reshape(mDemoData[][demo_share_young],M,T);
  mCounty_pop_young=reshape(mDemoData[][demo_pop_young],M,T);
  decl iAvgDensity=sumc(mCounty_density[][T-1].*mCounty_hh[][T-1])./sumc(mCounty_hh[][T-1]);
  vState_code=reshape(mDemoData[][demo_state_code],M,T)[][0];
  println("%c",{"year","variety ratio"},(vYear|vVariety)');
  
  /* Reshape wide */
  iMu_param=unique(mSpendingComponents_mode1[][demand_margin0]);
  iMu_amazon=unique(mSpendingComponents_mode1[][demand_a_margin]);
  iMu_mp=unique(mSpendingComponents_mode1[][demand_mp_margin]);
  println("Profit margin: ",iMu_param);
  decl mSpendingAlpha_mode1=reshape(mSpendingComponents_mode1[][demand_alpha],M,T);
  decl mSpendingAlpha_mode2=reshape(mSpendingComponents_mode2[][demand_alpha],M,T);
  decl mSpendingAlpha_mode3=reshape(mSpendingComponents_mode3[][demand_alpha],M,T);
  aSpendingInt=new array[3];
  aSpendingInt[0]=mSpendingAlpha_mode1;
  aSpendingInt[1]=mSpendingAlpha_mode2;
  aSpendingInt[2]=mSpendingAlpha_mode3;
  
  /* Construct matrices of amazon characteristics */
  vAmazonShare=reshape(mSpendingComponents_mode1[][demand_am_share],M,T)[0][];
  mRetailSpending=reshape(mSpendingComponents_mode1[][demand_avg_spending_annual_county],M,T);
  mAmazonPrice_tax_excl=reshape(mSpendingComponents_mode1[][demand_pre_laprice1],M,T);
  decl vAvgPrice_tax_excl=sumc(mAmazonPrice_tax_excl.*mCounty_hh)./sumc(mCounty_hh);
  println("Population weighted average price: ");
  println("%c",{"year","avg. price","variety"},vYear'~vAvgPrice_tax_excl'~vVariety');
  decl mCounty_per_100=reshape(mSpendingComponents_mode1[][demand_perc_100],M,T);
  decl iCES_coef_int=unique(mSpendingComponents_mode1[][demand_tax_coeff]);
  decl iCES_coef_slope=unique(mSpendingComponents_mode1[][demand_tax_coeff100]);
  vNetwork_density_obs=reshape(mSpendingComponents_mode1[][demand_density1],M,T)[0][];
  iDensityParam=unique(mSpendingComponents_mode1[][demand_density_coeff]);
  println("iCES_coef_int: ",iCES_coef_int);
  println("iCES_coef_slope: ",iCES_coef_slope);
  decl max_inc_share=(1.1-iCES_coef_int)/iCES_coef_slope;
  println("max_inc_share: ",max_inc_share);
  mCES_param=1-iCES_coef_int-iCES_coef_slope.*setbounds(mCounty_per_100,0,max_inc_share);  
  decl mAmazon_tax_obs=reshape(mDemoData[][demo_amazon_tax],M,T);
  println("Density parameter: ",iDensityParam);
  println("network density:: ",(vYear|vNetwork_density_obs)');
   
  /*************************************************************/  
  decl var;
  decl mFacilityData;
  decl mFC_wage,mFC_rent,mFC_density,id_sc,id_fc,vFC_cluster;
  decl vCluster_county_code,vCluster_state_code,id;
  decl vOutput,vLabor_cost,vLand_cost,vDensity_cost,vDensityCap_cost,mShipCost_variables,vRevenue,
    vNetRevenue,iHH_dist,iHH_vi,vHH_dist,vHH_dist_vi,vHH_vi,vHH_dist_nearest,vHH_dist_vi_nearest,vHH_vi_nearest,
    vAvgOrder_hh,mNetwork_distance,vNetwork_distance,vNetwork_density_distance,vNetrev_order;
  decl mAmazon_tax,vAmazon_tax,mCounty_demand,mAmazon_netrevenue,aNetwork_combined,vMedianOrder_hh,vAvgRev_hh,mAmazonSpending;
  decl mDummy_cluster,mDummy_fc_county,mFC_county_presence,vMinDist,vActive_cluster_fc;
  decl vSumCapacity,mDist,mDistance_network,mMatchProb,aActiveID,mRankFC,mMatchProb_active,mDist_county_cluster_active,mRankedProb,vShippingDistance,vWeight,vWeight_pop;
  decl mSortationNetwork,aSortationNetwork,aSortation_zone,aNetwork_sortation,mMatchProb_fc,vShipCost_county,vDemand_density,mOutput,mLabor,mDistance;
  decl vHH_taxable;
  decl vLongHaul_share,vLocalShipping_share;
  decl iYear0,iYear1,dYear;
  decl iSwap_capacity;
  decl iSwap_type;
  decl iLocation0,iLocation1,dLocation;
  decl year,t;
  decl iFC_density_param=0.97;
  decl vDiscounting=(0.95).^range(0,T-1);
  decl vParam_logistic_true=vParam_logistic;
  decl vAC,mAC,mCounty_demand_obs,mOutput_share;
  decl vGrid=range(-0.95,1.25,0.05),grid,mAC_results,vTotal_output;
  decl iSC=1;
  decl mLogisticResults=<>;
  decl mACResults=<>;
  decl mACDecomp=<>;
  decl vYear_id=range(1,T-1,3)';
  
  /* Loop across SC status */
  do{
    println("///////////////////////////////////////////////////////");
    /* Load counter-factual revenue and network */
    mFacilityData=loadmat(sprint(swap_dir,"Facility_panel_swap0.dta"),&aVarName_fc);
    mFacilityData[][fc_sq_ft]./=scale;
    mFacilityData=sortbyc(mFacilityData,<fc_id,fc_year>);
    vUnique_fcid=unique(mFacilityData[][fc_id]);
    nbFC=columns(vUnique_fcid);
    
    /* Reshape wide facility data: Activity and cost */
    vFC_id=reshape(mFacilityData[][fc_id],nbFC,T)[][0];
    mFC_activity=reshape(mFacilityData[][fc_dummy_active],nbFC,T);
    if(iSC==0) mFC_activity[id_sc][]=zeros(rows(id_sc),T); /* Remove SC facilities */
    vFC_capacity=reshape(mFacilityData[][fc_sq_ft],nbFC,T)[][0];
    vFC_type=reshape(mFacilityData[][fc_typeid],nbFC,T)[][0];
    mFC_wage=reshape(mFacilityData[][fc_imputed_wage],nbFC,T).*mFC_activity;
    mFC_rent=reshape(mFacilityData[][fc_county_rent_dis_imputed],nbFC,T).*mFC_activity;
    mFC_density=reshape(mFacilityData[][fc_pop_density],nbFC,T).*mFC_activity;
    vFC_cluster=reshape(mFacilityData[][fc_cluster_id],nbFC,T)[][0];
      
    /* Indicator function classifying each regular fulfillment center in each cluster: (nb facility) x N) */
    println("unique FC types: ",unique(vFC_type));
    mDummy_cluster=(vFC_cluster.==vCluster_id); /* nbFC x Nb cluster */    
    vDummy_sc=vFC_type.==type_sortation;
    vDummy_fc=(vFC_type.==type_sortable)+(vFC_type.==type_nonsortable);
    id_fc=vecindex(vDummy_fc,1);
    id_sc=vecindex(vDummy_sc,1);
    aID=new array[2];
    aID[0]=id_fc;
    aID[1]=id_sc;
    vFC_capacity[id_sc]=300000/scale;
    println("distribution of capacity (FC): ",quantilec(vFC_capacity[id_fc],<0,1/4,1/2,3/4,1>)');
    println("distribution of capacity (SC): ",quantilec(vFC_capacity[id_sc],<0,1/4,1/2,3/4,1>)');

    /* Cluster-county Matrix and input prices */
    mCluster_wage=new matrix[N][T];
    mCluster_rent=new matrix[N][T];
    mCluster_density=new matrix[N][T];
    mDummy_cluster_county=zeros(N,M);
    vNearestCounty_id=mincindex(mDist_county_cluster);
    /* Calculate input prices for each locations */
    vNearestCounty_id=mincindex(mDist_county_cluster);
    mCluster_wage=new matrix[N][T];
    mCluster_rent=new matrix[N][T];
    mCluster_density=new matrix[N][T];
    mDummy_cluster_county=zeros(N,M); /* Nb of cluster x Nb of counties */
    for(i=0;i<N;i++)
      {
	mDummy_cluster_county[i][vNearestCounty_id[i]]=1;
	mCluster_wage[i][]=mCounty_wage[vNearestCounty_id[i]][];
	mCluster_rent[i][]=mCounty_rent[vNearestCounty_id[i]][];
	mCluster_density[i][]=mCounty_density[vNearestCounty_id[i]][];      
      }      

    /* Create year-by-year sortation and delivery network */
    iprint=0;
    sortation_network_mp(&aNetwork_combined,mDummy_cluster);
       
    /* Compute taxes and spending by county */
    mDummy_fc_county=mDummy_cluster*mDummy_cluster_county; /* nb FC x nb Counties */
    mFC_county_presence=mDummy_fc_county[id_fc|id_sc][]'mFC_activity[id_fc|id_sc][]; /* Nb of active facilites per county */
    mFC_county_presence=(mFC_county_presence.>0);

    /* Compute Amazon tax */
    if(iTaxDelay==1) mAmazon_tax=reshape(mDemoData[][demo_amazon_tax],M,T);
    else amazon_tax_func(&mAmazon_tax,mFC_county_presence);
      
    /* Compute spending */
    spending_func(&mAmazonSpending,&mAmazon_netrevenue,&mCounty_demand,mAmazon_tax_obs,vNetwork_density_obs);
    mCounty_demand=(mCounty_demand.*mCounty_hh);
    
    /* Distribution of orders (year-by-year) */
    /* Loop across years */
    if(iSC==1) {
      for(year=0;year<T;year++)
	{
	  aActiveID=new array[2];
	  aActiveID[0]=selectifr(aID[0],mFC_activity[aID[0]][year].==1);
	  aActiveID[1]=selectifr(aID[1],mFC_activity[aID[1]][year].==1);
	  vSumCapacity=mDummy_cluster[aActiveID[0]][]'vFC_capacity[aActiveID[0]]; /* Sum capacity of active FCs */
	  vActive_cluster_fc=vecindex(vSumCapacity.>0,1); /* Active cluster ID */ 
	  logistic_output_func(&mOutput,&mDist,&mDistance_network,&mMatchProb,aNetwork_combined,mDummy_cluster,mCounty_demand,aActiveID,year);
	  mRankFC=new matrix[M][rows(vActive_cluster_fc)];
	  mMatchProb_active=mMatchProb[][vActive_cluster_fc];
	  mDist_county_cluster_active=mDist_county_cluster[][vActive_cluster_fc];
	  mRankedProb=new matrix[M][3];
	  vShippingDistance=new matrix[M][1];
	  vLongHaul_share=new matrix[M][1];
	  vLocalShipping_share=new matrix[M][1];	  
	  vAmazon_tax=100*vAmazonShare[year].*mAmazon_tax[][year];
	  for(i=0;i<M;i++)
	    {
	      mRankFC[i][]=sortcindex(mDist_county_cluster_active[i][]')';
	      mRankedProb[i][]=mMatchProb_active[i][mRankFC[i][:2]];
	      vShippingDistance[i]=sumr(mDist_county_cluster_active[i][].*mMatchProb_active[i][]);
	      vLongHaul_share[i]=sumr((mDist_county_cluster_active[i][].>400).*mMatchProb_active[i][]);
	      vLocalShipping_share[i]=sumr((mDist_county_cluster_active[i][].<100).*mMatchProb_active[i][]);
	    }
	  println("Mean distance and long/short distance ship: ",sumc(mCounty_demand[][year].*(vShippingDistance~vLongHaul_share~vLocalShipping_share))./sumc(mCounty_demand[][year]));
	  
	  vWeight=mCounty_demand[][year]./sumc(mCounty_demand[][year]);
	  vWeight_pop=mCounty_hh[][year]./sumc(mCounty_hh[][year]);
	  mLogisticResults|=(sumc(mAmazonSpending[][year].*vWeight_pop)|sumc(vAmazon_tax.*vWeight)|sumc(vWeight.*vShippingDistance)|
			     (sumc(mDist[][0])/sumc(mCounty_demand[][year]))|(sumc(mRankedProb.*vWeight)'))';

	  /* Shipping cost by county */
	  aNetwork_sortation=aNetwork_combined[iNetwork_sortation];
	  aSortation_zone=aNetwork_combined[iSortation_zone];
	  if(aActiveID[1]==<>) {
	    mSortationNetwork=zeros(M,1);
	  }
	  else mSortationNetwork=setbounds((aSortation_zone[year])[][aActiveID[1]]*aNetwork_sortation[year]',0,1);
	  mOutput_share=(vFC_capacity[aActiveID[0]].*mDummy_cluster[aActiveID[0]][vActive_cluster_fc])./(vSumCapacity[vActive_cluster_fc]');
	  mMatchProb_fc=(mMatchProb[][vActive_cluster_fc]*mOutput_share'); /* Dimension: Nb Counties x nb FC */
	  mShipCost_variables=new matrix[M][3];
	  mShipCost_variables[][0]=mCounty_demand[][year];
	  mShipCost_variables[][1]=sumr(mCounty_demand[][year].*mMatchProb[][vActive_cluster_fc].*mDist_county_cluster[][vActive_cluster_fc])/100;
	  mShipCost_variables[][2]=sumr(mCounty_demand[][year].*mMatchProb_fc.*mSortationNetwork);
	  vShipCost_county=(mShipCost_variables*vParam_cost[<iShip_int,iShip_dist,iShip_vi>])./mCounty_demand[][year];
	  
	  /* Demand density */
	  vDemand_density=mDummy_county_nearby*mCounty_demand[][year];
	  savemat(sprint("Results/Network_density_cost_year",vYear[year],".dta"),mCounty_code[][0]~vShipCost_county~vDemand_density~mCounty_demand[][year]~vShippingDistance~vLongHaul_share~vLocalShipping_share,
		  {"county_code","sc","density","demand","distance","long_haul","local_shipping"});
	}
    }

    /* Compute average cost given iSC */
    /* Rescale county demand */
    mCounty_demand_obs=mCounty_demand./scale;
  
    /* Calculate average cost at observed networks */
    mCounty_demand=mCounty_demand_obs;
    output_func_mp(&mOutput,&mLabor,&mDistance,&mNetwork_distance,aNetwork_combined,mDummy_cluster,mCounty_demand);
    mOutput.*=scale;
    mDistance.*=scale;
    mCounty_demand.*=scale;
    println("distribution of employees per FC (2018): ",quantilec(selectifr(mLabor[id_fc][T-1],mFC_activity[id_fc][T-1].==1),<0,1/4,1/2,3/4,1>)');
    println("distribution of employees per SC (2018): ",quantilec(selectifr(mLabor[id_sc][T-1],mFC_activity[id_sc][T-1].==1),<0,1/4,1/2,3/4,1>)');
    
    /* Labor and land cost */
    vOutput=sumc(mOutput[id_fc][])';	
    vLabor_cost=sumc(mLabor.*mFC_wage)';
    vLand_cost=sumc((vDummy_sc+vDummy_fc).*(vFC_capacity.*mFC_rent)*scale)';
    vDensityCap_cost=vParam_cost[iFC_dens]*sumc((vFC_capacity.*mFC_density)*scale)'/100;
    
    /* Shipping cost */
    mShipCost_variables=new matrix[T][3];
    mShipCost_variables[][0]=vOutput;
    mShipCost_variables[][1]=(sumr(mDistance[][<2,3>])/100);
    mShipCost_variables[][2]=mDistance[][0];
    
    /* Average cost vector */
    /* Calculate average cost and average variable cost per region */
    mAC=(mShipCost_variables*vParam_cost[<iShip_int,iShip_dist,iShip_vi>]~vLabor_cost~(vLand_cost~vDensityCap_cost))./vOutput;    
    mACDecomp~=mAC[][0]~(mAC./sumr(mAC));
    mAC~=sumr(mAC);    
    mAC=(sumc(mFC_activity[id_fc][])'~sumc(mFC_activity[id_sc][])'~sumc(vFC_capacity[id_fc].*mFC_activity[id_fc][])')~mAC;      
    if(iSC==1) {
      mACResults=mAC[vYear_id][];
    }
    if(iSC==0){
      mACResults|=mAC[T-1][];
    }

    iSC-=1;
  }while(iSC>=0);

  /* Select results every three years */
  mLogisticResults=mLogisticResults[vYear_id][];
  
  println("Average cost function ");
  println("%c",{"nb FC","nb SC","FC cap.","SC","L","Rent","Density","AC"},mACResults);
  println("Logistic Results: ","%c",{"spending","tax","dist","vi","R1","R2","R3","Cumu"},mLogisticResults);

  decl file = fopen(sprint("Results/Summary_stats_logistic.tex"), "w");
  fprintln(file,"\\centering");
  fprintln(file,"\\begin{tabular}{l|cccccccc}");
  fprintln(file,"\\hline");
  fprintln(file,"Years & Spending & Amazon & Distance & VI & \multicolumn{3}{c}{Fullfillment prob.} \\\ ");
  fprintln(file,"%r",{"2000","2003","2006","2009","2012","2015","2018"},"%cf",{"& %9.2f","& %9.2f","& %9.2f","& %9.2f","& %9.2f","& %9.2f","& %9.2f \\\ "},	   
	   "%c",{"& (\\$) ","& Tax ","& (miles)","& (\\%)","& 1st","& 2nd","& 3rd \\\ \\hline "},mLogisticResults);
  fprintln(file,"\\hline");
  fprintln(file,"\\end{tabular}");
  fclose(file);
 

  file = fopen(sprint("Results/Summary_stats_avgcost.tex"), "w");
  fprintln(file,"\\begin{minipage}{\linewidth}");
  fprintln(file,"\\centering");
  fprintln(file,"\\begin{tabular}{l|cccccccc}");
  fprintln(file,"\\hline");
  fprintln(file,"Years & FC & SC & FC Capacity & \multicolumn{4}{c}{Average cost components} \\\ ");
  fprintln(file,"& \\# & \\# &  x100K sq. ft. & Shipping & Labor & Rent & Density & Total \\\ \\hline");
  fprintln(file,"%r",{"2000","2003","2006","2009","2012","2015","2018","$2018^\\ast$"},
	   "%cf",{"& %9.0f","& %9.0f","& %9.2f","& %9.2f","& %9.2f","& %9.2f","& %9.2f","& %9.2f \\\ "},mACResults);
  fprintln(file,"\\hline");
  fprintln(file,"\\end{tabular}");
  fprintln(file,"\\footnotetext{Notes: $2018^\\ast$ corresponds to a counter-factual network with no sortation centers. Average cost components are calculated using the total network cost.}");
  fprintln(file,"\\end{minipage}");
  fclose(file);

  savemat(sprint("Results/AvgCost_decomposition.dta"),vYear'~mACDecomp,{"year","sc_obs","share_sc_obs","share_l_obs","share_rent_obs","share_density_obs",
	"sc_cf","share_sc_cf","share_l_cf","share_rent_cf","share_density_cf"});

  /*******************************************************************************************************/
  /* Evaluate average cost over a grid of demand */
  mAC_results=<>;
  vTotal_output=sumc(mCounty_demand_obs);
  mOutput_share=mCounty_demand_obs./vTotal_output;
  vGrid=vTotal_output~(1.05*maxr(vTotal_output))~(1.1*maxr(vTotal_output))~(1.25*maxr(vTotal_output));
  println("Grid of total demand: ",vGrid);
  for(grid=0;grid<columns(vGrid);grid++)
    {
      mCounty_demand=ones(M,T).*mOutput_share.*vGrid[grid];
      output_func_mp(&mOutput,&mLabor,&mDistance,&mNetwork_distance,aNetwork_combined,mDummy_cluster,mCounty_demand);
      mOutput.*=scale;
      mDistance.*=scale;
      mCounty_demand.*=scale;
      println("distribution of employees per FC (2018): ",quantilec(selectifr(mLabor[id_fc][T-1],mFC_activity[id_fc][T-1].==1),<0,1/4,1/2,3/4,1>)');
      println("distribution of employees per SC (2018): ",quantilec(selectifr(mLabor[id_sc][T-1],mFC_activity[id_sc][T-1].==1),<0,1/4,1/2,3/4,1>)');
      
      /* Labor and land cost */
      vOutput=sumc(mOutput[id_fc][])';	
      vLabor_cost=sumc(mLabor.*mFC_wage)';
      vLand_cost=sumc((vDummy_sc+vDummy_fc).*(vFC_capacity.*mFC_rent)*scale)';
      vDensityCap_cost=vParam_cost[iFC_dens]*sumc((vDummy_fc).*(vFC_capacity.*mFC_density)*scale)'/100;

      /* Shipping cost */
      mShipCost_variables=new matrix[T][3];
      mShipCost_variables[][0]=vOutput;
      mShipCost_variables[][1]=(sumr(mDistance[][<2,3>])/100);
      mShipCost_variables[][2]=mDistance[][0];
  
      vAC=(mShipCost_variables*vParam_cost[<iShip_int,iShip_dist,iShip_vi>]+vLabor_cost+vDensityCap_cost+vLand_cost)./vOutput;
      mAC_results|=constant(grid,T,1)~vYear'~vOutput~vAC;
    }
  println("mResults: ",mAC_results);
  savemat(sprint("Results/AC_demand_grid_",iEstimator,".dta"),mAC_results,{"demand_grid","year","Output","AC"});
}


